from palm.palm import ProtoBase, is_string, RepeatedSequence, ProtoValueError

_PB_type = type
_PB_finalizers = []

from foo_palm import *

class Secret(ProtoBase):
    _required = [1, 2]
    _field_map = {'message': 2, 'code': 1}
    
    def __init__(self, _pbf_buf='', _pbf_parent_callback=None, **kw):
        self._pbf_parent_callback = _pbf_parent_callback
        self._cache = {}
        self._pbf_establish_parent_callback = None
        ProtoBase.__init__(self, _pbf_buf, **kw)

    @classmethod
    def _pbf_finalize(cls):
        for c in cls._pbf_finalizers:
            c(cls)
        del cls._pbf_finalizers

    @classmethod
    def fields(cls):
        return ['code', 'message']

    def modified(self):
        return self._evermod

    def __contains__(self, item):
        try:
            return getattr(self, '%s__exists' % item)
        except AttributeError:
            return False

    _pbf_strings = []
    _pbf_finalizers = []

    def __str__(self):
        return '\n'.join('%s: %s' % (f, repr(getattr(self, '_get_%s' % f)())) for f in self.fields()
                          if getattr(self, '%s__exists' % f))

    def _get_code(self):
        if 1 in self._cache:
            r = self._cache[1]
        else:
            r = self._buf_get(1, ProtoBase.TYPE_int32, 'code')
            self._cache[1] = r
        return r

    def _establish_parentage_code(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_code), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_code
                v._pbf_establish_parent_callback = self._establish_parentage_code

    def _set_code(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_code(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field code"
            raise ProtoValueError(list_assign_error)
        self._cache[1] = v
        self._mods[1] = ProtoBase.TYPE_int32

    def _mod_code(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[1] = ProtoBase.TYPE_int32

    def _del_code(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 1 in self._cache:
            del self._cache[1]
        if 1 in self._mods:
            del self._mods[1]
        self._buf_del(1)

    _pb_field_name_1 = "code"

    code = property(_get_code, _set_code, _del_code)

    @property
    def code__exists(self):
        return 1 in self._mods or self._buf_exists(1)

    @property
    def code__type(self):
        return ProtoBase.TYPE_int32

    def _finalize_code(cls):
        if is_string(ProtoBase.TYPE_int32):
            cls._pbf_strings.append(1)
        elif _PB_type(ProtoBase.TYPE_int32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_int32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_int32.pb_subtype):
                cls._pbf_strings.append(1)

    _pbf_finalizers.append(_finalize_code)


    def _get_message(self):
        if 2 in self._cache:
            r = self._cache[2]
        else:
            r = self._buf_get(2, ProtoBase.TYPE_string, 'message')
            self._cache[2] = r
        return r

    def _establish_parentage_message(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_message), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_message
                v._pbf_establish_parent_callback = self._establish_parentage_message

    def _set_message(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_message(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field message"
            raise ProtoValueError(list_assign_error)
        self._cache[2] = v
        self._mods[2] = ProtoBase.TYPE_string

    def _mod_message(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[2] = ProtoBase.TYPE_string

    def _del_message(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 2 in self._cache:
            del self._cache[2]
        if 2 in self._mods:
            del self._mods[2]
        self._buf_del(2)

    _pb_field_name_2 = "message"

    message = property(_get_message, _set_message, _del_message)

    @property
    def message__exists(self):
        return 2 in self._mods or self._buf_exists(2)

    @property
    def message__type(self):
        return ProtoBase.TYPE_string

    def _finalize_message(cls):
        if is_string(ProtoBase.TYPE_string):
            cls._pbf_strings.append(2)
        elif _PB_type(ProtoBase.TYPE_string) is _PB_type:
            assert issubclass(ProtoBase.TYPE_string, RepeatedSequence)
            if is_string(ProtoBase.TYPE_string.pb_subtype):
                cls._pbf_strings.append(2)

    _pbf_finalizers.append(_finalize_message)


TYPE_Secret = Secret
_PB_finalizers.append('Secret')

class Test(ProtoBase):
    _required = [50, 51, 52]
    _field_map = {'r_sha1': 31, 'chosen_class': 57, 'r_yn': 48, 'answer2': 55, 'r_secret': 56, 'req_a': 50, 'r_h': 40, 'r_i': 41, 'secret': 53, 'r_k': 42, 'r_l': 43, 'r_m': 44, 'r_n': 45, 'r_o': 46, 'msg': 17, 'r_a': 32, 'r_b': 33, 'r_c': 34, 'r_d': 35, 'r_e': 36, 'r_f': 37, 'cls': 19, 'yn': 18, 'answer1': 54, 'r_msg': 47, 'req_b': 51, 'b': 3, 'r_cls': 49, 'a': 2, 'req_c': 52, 'c': 4, 'sha1': 1, 'e': 6, 'd': 5, 'g': 9, 'f': 7, 'i': 11, 'h': 10, 'k': 12, 'm': 14, 'l': 13, 'o': 16, 'n': 15, 'q': 22, 'p': 21, 'r': 23, 'r_g': 39}
    
    def __init__(self, _pbf_buf='', _pbf_parent_callback=None, **kw):
        self._pbf_parent_callback = _pbf_parent_callback
        self._cache = {}
        self._pbf_establish_parent_callback = None
        ProtoBase.__init__(self, _pbf_buf, **kw)

    @classmethod
    def _pbf_finalize(cls):
        for c in cls._pbf_finalizers:
            c(cls)
        del cls._pbf_finalizers

    @classmethod
    def fields(cls):
        return ['sha1', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'k', 'l', 'm', 'n', 'o', 'msg', 'yn', 'cls', 'p', 'q', 'r', 'r_sha1', 'r_a', 'r_b', 'r_c', 'r_d', 'r_e', 'r_f', 'r_g', 'r_h', 'r_i', 'r_k', 'r_l', 'r_m', 'r_n', 'r_o', 'r_msg', 'r_yn', 'r_cls', 'req_a', 'req_b', 'req_c', 'secret', 'answer1', 'answer2', 'r_secret', 'chosen_class']

    def modified(self):
        return self._evermod

    def __contains__(self, item):
        try:
            return getattr(self, '%s__exists' % item)
        except AttributeError:
            return False

    _pbf_strings = []
    _pbf_finalizers = []

    def __str__(self):
        return '\n'.join('%s: %s' % (f, repr(getattr(self, '_get_%s' % f)())) for f in self.fields()
                          if getattr(self, '%s__exists' % f))
    
    # Enumeration: AirplaneClass
        
    FIRST = 0
        
    ECONOMY = 1
        
    BUSINESS = 2
        
    TYPE_AirplaneClass = ProtoBase.TYPE_int32
        
    _AirplaneClass__map = {1: 'ECONOMY', 2: 'BUSINESS', 0: 'FIRST'}
        
    @classmethod
    def get_AirplaneClass_name(cls, v):
        return cls._AirplaneClass__map[v]
        
    class Foo(ProtoBase):
        _required = []
        _field_map = {'flop': 9, 'baz': 8}
        
        def __init__(self, _pbf_buf='', _pbf_parent_callback=None, **kw):
            self._pbf_parent_callback = _pbf_parent_callback
            self._cache = {}
            self._pbf_establish_parent_callback = None
            ProtoBase.__init__(self, _pbf_buf, **kw)
    
        @classmethod
        def _pbf_finalize(cls):
            for c in cls._pbf_finalizers:
                c(cls)
            del cls._pbf_finalizers
    
        @classmethod
        def fields(cls):
            return ['baz', 'flop']
    
        def modified(self):
            return self._evermod
    
        def __contains__(self, item):
            try:
                return getattr(self, '%s__exists' % item)
            except AttributeError:
                return False
    
        _pbf_strings = []
        _pbf_finalizers = []
    
        def __str__(self):
            return '\n'.join('%s: %s' % (f, repr(getattr(self, '_get_%s' % f)())) for f in self.fields()
                              if getattr(self, '%s__exists' % f))
            
        class Flop(ProtoBase):
            _required = []
            _field_map = {'desc': 1}
            
            def __init__(self, _pbf_buf='', _pbf_parent_callback=None, **kw):
                self._pbf_parent_callback = _pbf_parent_callback
                self._cache = {}
                self._pbf_establish_parent_callback = None
                ProtoBase.__init__(self, _pbf_buf, **kw)
        
            @classmethod
            def _pbf_finalize(cls):
                for c in cls._pbf_finalizers:
                    c(cls)
                del cls._pbf_finalizers
        
            @classmethod
            def fields(cls):
                return ['desc']
        
            def modified(self):
                return self._evermod
        
            def __contains__(self, item):
                try:
                    return getattr(self, '%s__exists' % item)
                except AttributeError:
                    return False
        
            _pbf_strings = []
            _pbf_finalizers = []
        
            def __str__(self):
                return '\n'.join('%s: %s' % (f, repr(getattr(self, '_get_%s' % f)())) for f in self.fields()
                                  if getattr(self, '%s__exists' % f))
                
            def _get_desc(self):
                if 1 in self._cache:
                    r = self._cache[1]
                else:
                    r = self._buf_get(1, ProtoBase.TYPE_string, 'desc')
                    self._cache[1] = r
                return r
        
            def _establish_parentage_desc(self, v):
                if isinstance(v, (ProtoBase, RepeatedSequence)):
                    if v._pbf_parent_callback:
                        assert (v._pbf_parent_callback == self._mod_desc), "subobjects can only have one parent--use copy()?"
                    else:
                        v._pbf_parent_callback = self._mod_desc
                        v._pbf_establish_parent_callback = self._establish_parentage_desc
        
            def _set_desc(self, v, modifying=True):
                self._evermod = modifying or self._evermod
                if self._pbf_parent_callback:
                    self._pbf_parent_callback()
                if isinstance(v, (ProtoBase, RepeatedSequence)):
                    self._establish_parentage_desc(v)
                elif isinstance(v, list):
                    list_assign_error = "Can't assign list to repeated field desc"
                    raise ProtoValueError(list_assign_error)
                self._cache[1] = v
                self._mods[1] = ProtoBase.TYPE_string
        
            def _mod_desc(self):
                self._evermod = True
                if self._pbf_parent_callback:
                    self._pbf_parent_callback()
                self._mods[1] = ProtoBase.TYPE_string
        
            def _del_desc(self):
                self._evermod = True
                if self._pbf_parent_callback:
                    self._pbf_parent_callback()
                if 1 in self._cache:
                    del self._cache[1]
                if 1 in self._mods:
                    del self._mods[1]
                self._buf_del(1)
        
            _pb_field_name_1 = "desc"
        
            desc = property(_get_desc, _set_desc, _del_desc)
        
            @property
            def desc__exists(self):
                return 1 in self._mods or self._buf_exists(1)
        
            @property
            def desc__type(self):
                return ProtoBase.TYPE_string
        
            def _finalize_desc(cls):
                if is_string(ProtoBase.TYPE_string):
                    cls._pbf_strings.append(1)
                elif _PB_type(ProtoBase.TYPE_string) is _PB_type:
                    assert issubclass(ProtoBase.TYPE_string, RepeatedSequence)
                    if is_string(ProtoBase.TYPE_string.pb_subtype):
                        cls._pbf_strings.append(1)
        
            _pbf_finalizers.append(_finalize_desc)
        
                
        TYPE_Flop = Flop
        _PB_finalizers.append('Test.Foo.Flop')
            
        TYPE_Flop = Flop
        
        def _get_baz(self):
            if 8 in self._cache:
                r = self._cache[8]
            else:
                r = self._buf_get(8, ProtoBase.TYPE_string, 'baz')
                self._cache[8] = r
            return r
    
        def _establish_parentage_baz(self, v):
            if isinstance(v, (ProtoBase, RepeatedSequence)):
                if v._pbf_parent_callback:
                    assert (v._pbf_parent_callback == self._mod_baz), "subobjects can only have one parent--use copy()?"
                else:
                    v._pbf_parent_callback = self._mod_baz
                    v._pbf_establish_parent_callback = self._establish_parentage_baz
    
        def _set_baz(self, v, modifying=True):
            self._evermod = modifying or self._evermod
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            if isinstance(v, (ProtoBase, RepeatedSequence)):
                self._establish_parentage_baz(v)
            elif isinstance(v, list):
                list_assign_error = "Can't assign list to repeated field baz"
                raise ProtoValueError(list_assign_error)
            self._cache[8] = v
            self._mods[8] = ProtoBase.TYPE_string
    
        def _mod_baz(self):
            self._evermod = True
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            self._mods[8] = ProtoBase.TYPE_string
    
        def _del_baz(self):
            self._evermod = True
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            if 8 in self._cache:
                del self._cache[8]
            if 8 in self._mods:
                del self._mods[8]
            self._buf_del(8)
    
        _pb_field_name_8 = "baz"
    
        baz = property(_get_baz, _set_baz, _del_baz)
    
        @property
        def baz__exists(self):
            return 8 in self._mods or self._buf_exists(8)
    
        @property
        def baz__type(self):
            return ProtoBase.TYPE_string
    
        def _finalize_baz(cls):
            if is_string(ProtoBase.TYPE_string):
                cls._pbf_strings.append(8)
            elif _PB_type(ProtoBase.TYPE_string) is _PB_type:
                assert issubclass(ProtoBase.TYPE_string, RepeatedSequence)
                if is_string(ProtoBase.TYPE_string.pb_subtype):
                    cls._pbf_strings.append(8)
    
        _pbf_finalizers.append(_finalize_baz)
    
        
        def _get_flop(self):
            if 9 in self._cache:
                r = self._cache[9]
            else:
                r = self._buf_get(9, Test.Foo.TYPE_Flop, 'flop')
                self._cache[9] = r
            return r
    
        def _establish_parentage_flop(self, v):
            if isinstance(v, (ProtoBase, RepeatedSequence)):
                if v._pbf_parent_callback:
                    assert (v._pbf_parent_callback == self._mod_flop), "subobjects can only have one parent--use copy()?"
                else:
                    v._pbf_parent_callback = self._mod_flop
                    v._pbf_establish_parent_callback = self._establish_parentage_flop
    
        def _set_flop(self, v, modifying=True):
            self._evermod = modifying or self._evermod
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            if isinstance(v, (ProtoBase, RepeatedSequence)):
                self._establish_parentage_flop(v)
            elif isinstance(v, list):
                list_assign_error = "Can't assign list to repeated field flop"
                raise ProtoValueError(list_assign_error)
            self._cache[9] = v
            self._mods[9] = Test.Foo.TYPE_Flop
    
        def _mod_flop(self):
            self._evermod = True
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            self._mods[9] = Test.Foo.TYPE_Flop
    
        def _del_flop(self):
            self._evermod = True
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            if 9 in self._cache:
                del self._cache[9]
            if 9 in self._mods:
                del self._mods[9]
            self._buf_del(9)
    
        _pb_field_name_9 = "flop"
    
        flop = property(_get_flop, _set_flop, _del_flop)
    
        @property
        def flop__exists(self):
            return 9 in self._mods or self._buf_exists(9)
    
        @property
        def flop__type(self):
            return Test.Foo.TYPE_Flop
    
        def _finalize_flop(cls):
            if is_string(Test.Foo.TYPE_Flop):
                cls._pbf_strings.append(9)
            elif _PB_type(Test.Foo.TYPE_Flop) is _PB_type:
                assert issubclass(Test.Foo.TYPE_Flop, RepeatedSequence)
                if is_string(Test.Foo.TYPE_Flop.pb_subtype):
                    cls._pbf_strings.append(9)
    
        _pbf_finalizers.append(_finalize_flop)
    
        
    TYPE_Foo = Foo
    _PB_finalizers.append('Test.Foo')
    
    TYPE_Foo = Foo

    def _get_sha1(self):
        if 1 in self._cache:
            r = self._cache[1]
        else:
            r = self._buf_get(1, ProtoBase.TYPE_string, 'sha1')
            self._cache[1] = r
        return r

    def _establish_parentage_sha1(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_sha1), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_sha1
                v._pbf_establish_parent_callback = self._establish_parentage_sha1

    def _set_sha1(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_sha1(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field sha1"
            raise ProtoValueError(list_assign_error)
        self._cache[1] = v
        self._mods[1] = ProtoBase.TYPE_string

    def _mod_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[1] = ProtoBase.TYPE_string

    def _del_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 1 in self._cache:
            del self._cache[1]
        if 1 in self._mods:
            del self._mods[1]
        self._buf_del(1)

    _pb_field_name_1 = "sha1"

    sha1 = property(_get_sha1, _set_sha1, _del_sha1)

    @property
    def sha1__exists(self):
        return 1 in self._mods or self._buf_exists(1)

    @property
    def sha1__type(self):
        return ProtoBase.TYPE_string

    def _finalize_sha1(cls):
        if is_string(ProtoBase.TYPE_string):
            cls._pbf_strings.append(1)
        elif _PB_type(ProtoBase.TYPE_string) is _PB_type:
            assert issubclass(ProtoBase.TYPE_string, RepeatedSequence)
            if is_string(ProtoBase.TYPE_string.pb_subtype):
                cls._pbf_strings.append(1)

    _pbf_finalizers.append(_finalize_sha1)


    def _get_a(self):
        if 2 in self._cache:
            r = self._cache[2]
        else:
            r = self._buf_get(2, ProtoBase.TYPE_uint32, 'a')
            self._cache[2] = r
        return r

    def _establish_parentage_a(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_a), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_a
                v._pbf_establish_parent_callback = self._establish_parentage_a

    def _set_a(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_a(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field a"
            raise ProtoValueError(list_assign_error)
        self._cache[2] = v
        self._mods[2] = ProtoBase.TYPE_uint32

    def _mod_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[2] = ProtoBase.TYPE_uint32

    def _del_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 2 in self._cache:
            del self._cache[2]
        if 2 in self._mods:
            del self._mods[2]
        self._buf_del(2)

    _pb_field_name_2 = "a"

    a = property(_get_a, _set_a, _del_a)

    @property
    def a__exists(self):
        return 2 in self._mods or self._buf_exists(2)

    @property
    def a__type(self):
        return ProtoBase.TYPE_uint32

    def _finalize_a(cls):
        if is_string(ProtoBase.TYPE_uint32):
            cls._pbf_strings.append(2)
        elif _PB_type(ProtoBase.TYPE_uint32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_uint32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_uint32.pb_subtype):
                cls._pbf_strings.append(2)

    _pbf_finalizers.append(_finalize_a)


    def _get_b(self):
        if 3 in self._cache:
            r = self._cache[3]
        else:
            r = self._buf_get(3, ProtoBase.TYPE_int32, 'b')
            self._cache[3] = r
        return r

    def _establish_parentage_b(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_b), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_b
                v._pbf_establish_parent_callback = self._establish_parentage_b

    def _set_b(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_b(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field b"
            raise ProtoValueError(list_assign_error)
        self._cache[3] = v
        self._mods[3] = ProtoBase.TYPE_int32

    def _mod_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[3] = ProtoBase.TYPE_int32

    def _del_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 3 in self._cache:
            del self._cache[3]
        if 3 in self._mods:
            del self._mods[3]
        self._buf_del(3)

    _pb_field_name_3 = "b"

    b = property(_get_b, _set_b, _del_b)

    @property
    def b__exists(self):
        return 3 in self._mods or self._buf_exists(3)

    @property
    def b__type(self):
        return ProtoBase.TYPE_int32

    def _finalize_b(cls):
        if is_string(ProtoBase.TYPE_int32):
            cls._pbf_strings.append(3)
        elif _PB_type(ProtoBase.TYPE_int32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_int32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_int32.pb_subtype):
                cls._pbf_strings.append(3)

    _pbf_finalizers.append(_finalize_b)


    def _get_c(self):
        if 4 in self._cache:
            r = self._cache[4]
        else:
            r = self._buf_get(4, ProtoBase.TYPE_sint32, 'c')
            self._cache[4] = r
        return r

    def _establish_parentage_c(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_c), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_c
                v._pbf_establish_parent_callback = self._establish_parentage_c

    def _set_c(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_c(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field c"
            raise ProtoValueError(list_assign_error)
        self._cache[4] = v
        self._mods[4] = ProtoBase.TYPE_sint32

    def _mod_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[4] = ProtoBase.TYPE_sint32

    def _del_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 4 in self._cache:
            del self._cache[4]
        if 4 in self._mods:
            del self._mods[4]
        self._buf_del(4)

    _pb_field_name_4 = "c"

    c = property(_get_c, _set_c, _del_c)

    @property
    def c__exists(self):
        return 4 in self._mods or self._buf_exists(4)

    @property
    def c__type(self):
        return ProtoBase.TYPE_sint32

    def _finalize_c(cls):
        if is_string(ProtoBase.TYPE_sint32):
            cls._pbf_strings.append(4)
        elif _PB_type(ProtoBase.TYPE_sint32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_sint32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_sint32.pb_subtype):
                cls._pbf_strings.append(4)

    _pbf_finalizers.append(_finalize_c)


    def _get_d(self):
        if 5 in self._cache:
            r = self._cache[5]
        else:
            r = self._buf_get(5, ProtoBase.TYPE_uint64, 'd')
            self._cache[5] = r
        return r

    def _establish_parentage_d(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_d), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_d
                v._pbf_establish_parent_callback = self._establish_parentage_d

    def _set_d(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_d(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field d"
            raise ProtoValueError(list_assign_error)
        self._cache[5] = v
        self._mods[5] = ProtoBase.TYPE_uint64

    def _mod_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[5] = ProtoBase.TYPE_uint64

    def _del_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 5 in self._cache:
            del self._cache[5]
        if 5 in self._mods:
            del self._mods[5]
        self._buf_del(5)

    _pb_field_name_5 = "d"

    d = property(_get_d, _set_d, _del_d)

    @property
    def d__exists(self):
        return 5 in self._mods or self._buf_exists(5)

    @property
    def d__type(self):
        return ProtoBase.TYPE_uint64

    def _finalize_d(cls):
        if is_string(ProtoBase.TYPE_uint64):
            cls._pbf_strings.append(5)
        elif _PB_type(ProtoBase.TYPE_uint64) is _PB_type:
            assert issubclass(ProtoBase.TYPE_uint64, RepeatedSequence)
            if is_string(ProtoBase.TYPE_uint64.pb_subtype):
                cls._pbf_strings.append(5)

    _pbf_finalizers.append(_finalize_d)


    def _get_e(self):
        if 6 in self._cache:
            r = self._cache[6]
        else:
            r = self._buf_get(6, ProtoBase.TYPE_int64, 'e')
            self._cache[6] = r
        return r

    def _establish_parentage_e(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_e), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_e
                v._pbf_establish_parent_callback = self._establish_parentage_e

    def _set_e(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_e(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field e"
            raise ProtoValueError(list_assign_error)
        self._cache[6] = v
        self._mods[6] = ProtoBase.TYPE_int64

    def _mod_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[6] = ProtoBase.TYPE_int64

    def _del_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 6 in self._cache:
            del self._cache[6]
        if 6 in self._mods:
            del self._mods[6]
        self._buf_del(6)

    _pb_field_name_6 = "e"

    e = property(_get_e, _set_e, _del_e)

    @property
    def e__exists(self):
        return 6 in self._mods or self._buf_exists(6)

    @property
    def e__type(self):
        return ProtoBase.TYPE_int64

    def _finalize_e(cls):
        if is_string(ProtoBase.TYPE_int64):
            cls._pbf_strings.append(6)
        elif _PB_type(ProtoBase.TYPE_int64) is _PB_type:
            assert issubclass(ProtoBase.TYPE_int64, RepeatedSequence)
            if is_string(ProtoBase.TYPE_int64.pb_subtype):
                cls._pbf_strings.append(6)

    _pbf_finalizers.append(_finalize_e)


    def _get_f(self):
        if 7 in self._cache:
            r = self._cache[7]
        else:
            r = self._buf_get(7, ProtoBase.TYPE_sint64, 'f')
            self._cache[7] = r
        return r

    def _establish_parentage_f(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_f), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_f
                v._pbf_establish_parent_callback = self._establish_parentage_f

    def _set_f(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_f(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field f"
            raise ProtoValueError(list_assign_error)
        self._cache[7] = v
        self._mods[7] = ProtoBase.TYPE_sint64

    def _mod_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[7] = ProtoBase.TYPE_sint64

    def _del_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 7 in self._cache:
            del self._cache[7]
        if 7 in self._mods:
            del self._mods[7]
        self._buf_del(7)

    _pb_field_name_7 = "f"

    f = property(_get_f, _set_f, _del_f)

    @property
    def f__exists(self):
        return 7 in self._mods or self._buf_exists(7)

    @property
    def f__type(self):
        return ProtoBase.TYPE_sint64

    def _finalize_f(cls):
        if is_string(ProtoBase.TYPE_sint64):
            cls._pbf_strings.append(7)
        elif _PB_type(ProtoBase.TYPE_sint64) is _PB_type:
            assert issubclass(ProtoBase.TYPE_sint64, RepeatedSequence)
            if is_string(ProtoBase.TYPE_sint64.pb_subtype):
                cls._pbf_strings.append(7)

    _pbf_finalizers.append(_finalize_f)


    def _get_g(self):
        if 9 in self._cache:
            r = self._cache[9]
        else:
            r = self._buf_get(9, ProtoBase.TYPE_fixed64, 'g')
            self._cache[9] = r
        return r

    def _establish_parentage_g(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_g), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_g
                v._pbf_establish_parent_callback = self._establish_parentage_g

    def _set_g(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_g(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field g"
            raise ProtoValueError(list_assign_error)
        self._cache[9] = v
        self._mods[9] = ProtoBase.TYPE_fixed64

    def _mod_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[9] = ProtoBase.TYPE_fixed64

    def _del_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 9 in self._cache:
            del self._cache[9]
        if 9 in self._mods:
            del self._mods[9]
        self._buf_del(9)

    _pb_field_name_9 = "g"

    g = property(_get_g, _set_g, _del_g)

    @property
    def g__exists(self):
        return 9 in self._mods or self._buf_exists(9)

    @property
    def g__type(self):
        return ProtoBase.TYPE_fixed64

    def _finalize_g(cls):
        if is_string(ProtoBase.TYPE_fixed64):
            cls._pbf_strings.append(9)
        elif _PB_type(ProtoBase.TYPE_fixed64) is _PB_type:
            assert issubclass(ProtoBase.TYPE_fixed64, RepeatedSequence)
            if is_string(ProtoBase.TYPE_fixed64.pb_subtype):
                cls._pbf_strings.append(9)

    _pbf_finalizers.append(_finalize_g)


    def _get_h(self):
        if 10 in self._cache:
            r = self._cache[10]
        else:
            r = self._buf_get(10, ProtoBase.TYPE_sfixed64, 'h')
            self._cache[10] = r
        return r

    def _establish_parentage_h(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_h), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_h
                v._pbf_establish_parent_callback = self._establish_parentage_h

    def _set_h(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_h(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field h"
            raise ProtoValueError(list_assign_error)
        self._cache[10] = v
        self._mods[10] = ProtoBase.TYPE_sfixed64

    def _mod_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[10] = ProtoBase.TYPE_sfixed64

    def _del_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 10 in self._cache:
            del self._cache[10]
        if 10 in self._mods:
            del self._mods[10]
        self._buf_del(10)

    _pb_field_name_10 = "h"

    h = property(_get_h, _set_h, _del_h)

    @property
    def h__exists(self):
        return 10 in self._mods or self._buf_exists(10)

    @property
    def h__type(self):
        return ProtoBase.TYPE_sfixed64

    def _finalize_h(cls):
        if is_string(ProtoBase.TYPE_sfixed64):
            cls._pbf_strings.append(10)
        elif _PB_type(ProtoBase.TYPE_sfixed64) is _PB_type:
            assert issubclass(ProtoBase.TYPE_sfixed64, RepeatedSequence)
            if is_string(ProtoBase.TYPE_sfixed64.pb_subtype):
                cls._pbf_strings.append(10)

    _pbf_finalizers.append(_finalize_h)


    def _get_i(self):
        if 11 in self._cache:
            r = self._cache[11]
        else:
            r = self._buf_get(11, ProtoBase.TYPE_sfixed64, 'i')
            self._cache[11] = r
        return r

    def _establish_parentage_i(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_i), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_i
                v._pbf_establish_parent_callback = self._establish_parentage_i

    def _set_i(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_i(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field i"
            raise ProtoValueError(list_assign_error)
        self._cache[11] = v
        self._mods[11] = ProtoBase.TYPE_sfixed64

    def _mod_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[11] = ProtoBase.TYPE_sfixed64

    def _del_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 11 in self._cache:
            del self._cache[11]
        if 11 in self._mods:
            del self._mods[11]
        self._buf_del(11)

    _pb_field_name_11 = "i"

    i = property(_get_i, _set_i, _del_i)

    @property
    def i__exists(self):
        return 11 in self._mods or self._buf_exists(11)

    @property
    def i__type(self):
        return ProtoBase.TYPE_sfixed64

    def _finalize_i(cls):
        if is_string(ProtoBase.TYPE_sfixed64):
            cls._pbf_strings.append(11)
        elif _PB_type(ProtoBase.TYPE_sfixed64) is _PB_type:
            assert issubclass(ProtoBase.TYPE_sfixed64, RepeatedSequence)
            if is_string(ProtoBase.TYPE_sfixed64.pb_subtype):
                cls._pbf_strings.append(11)

    _pbf_finalizers.append(_finalize_i)


    def _get_k(self):
        if 12 in self._cache:
            r = self._cache[12]
        else:
            r = self._buf_get(12, ProtoBase.TYPE_double, 'k')
            self._cache[12] = r
        return r

    def _establish_parentage_k(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_k), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_k
                v._pbf_establish_parent_callback = self._establish_parentage_k

    def _set_k(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_k(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field k"
            raise ProtoValueError(list_assign_error)
        self._cache[12] = v
        self._mods[12] = ProtoBase.TYPE_double

    def _mod_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[12] = ProtoBase.TYPE_double

    def _del_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 12 in self._cache:
            del self._cache[12]
        if 12 in self._mods:
            del self._mods[12]
        self._buf_del(12)

    _pb_field_name_12 = "k"

    k = property(_get_k, _set_k, _del_k)

    @property
    def k__exists(self):
        return 12 in self._mods or self._buf_exists(12)

    @property
    def k__type(self):
        return ProtoBase.TYPE_double

    def _finalize_k(cls):
        if is_string(ProtoBase.TYPE_double):
            cls._pbf_strings.append(12)
        elif _PB_type(ProtoBase.TYPE_double) is _PB_type:
            assert issubclass(ProtoBase.TYPE_double, RepeatedSequence)
            if is_string(ProtoBase.TYPE_double.pb_subtype):
                cls._pbf_strings.append(12)

    _pbf_finalizers.append(_finalize_k)


    def _get_l(self):
        if 13 in self._cache:
            r = self._cache[13]
        else:
            r = self._buf_get(13, ProtoBase.TYPE_fixed32, 'l')
            self._cache[13] = r
        return r

    def _establish_parentage_l(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_l), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_l
                v._pbf_establish_parent_callback = self._establish_parentage_l

    def _set_l(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_l(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field l"
            raise ProtoValueError(list_assign_error)
        self._cache[13] = v
        self._mods[13] = ProtoBase.TYPE_fixed32

    def _mod_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[13] = ProtoBase.TYPE_fixed32

    def _del_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 13 in self._cache:
            del self._cache[13]
        if 13 in self._mods:
            del self._mods[13]
        self._buf_del(13)

    _pb_field_name_13 = "l"

    l = property(_get_l, _set_l, _del_l)

    @property
    def l__exists(self):
        return 13 in self._mods or self._buf_exists(13)

    @property
    def l__type(self):
        return ProtoBase.TYPE_fixed32

    def _finalize_l(cls):
        if is_string(ProtoBase.TYPE_fixed32):
            cls._pbf_strings.append(13)
        elif _PB_type(ProtoBase.TYPE_fixed32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_fixed32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_fixed32.pb_subtype):
                cls._pbf_strings.append(13)

    _pbf_finalizers.append(_finalize_l)


    def _get_m(self):
        if 14 in self._cache:
            r = self._cache[14]
        else:
            r = self._buf_get(14, ProtoBase.TYPE_sfixed32, 'm')
            self._cache[14] = r
        return r

    def _establish_parentage_m(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_m), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_m
                v._pbf_establish_parent_callback = self._establish_parentage_m

    def _set_m(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_m(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field m"
            raise ProtoValueError(list_assign_error)
        self._cache[14] = v
        self._mods[14] = ProtoBase.TYPE_sfixed32

    def _mod_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[14] = ProtoBase.TYPE_sfixed32

    def _del_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 14 in self._cache:
            del self._cache[14]
        if 14 in self._mods:
            del self._mods[14]
        self._buf_del(14)

    _pb_field_name_14 = "m"

    m = property(_get_m, _set_m, _del_m)

    @property
    def m__exists(self):
        return 14 in self._mods or self._buf_exists(14)

    @property
    def m__type(self):
        return ProtoBase.TYPE_sfixed32

    def _finalize_m(cls):
        if is_string(ProtoBase.TYPE_sfixed32):
            cls._pbf_strings.append(14)
        elif _PB_type(ProtoBase.TYPE_sfixed32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_sfixed32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_sfixed32.pb_subtype):
                cls._pbf_strings.append(14)

    _pbf_finalizers.append(_finalize_m)


    def _get_n(self):
        if 15 in self._cache:
            r = self._cache[15]
        else:
            r = self._buf_get(15, ProtoBase.TYPE_sfixed32, 'n')
            self._cache[15] = r
        return r

    def _establish_parentage_n(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_n), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_n
                v._pbf_establish_parent_callback = self._establish_parentage_n

    def _set_n(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_n(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field n"
            raise ProtoValueError(list_assign_error)
        self._cache[15] = v
        self._mods[15] = ProtoBase.TYPE_sfixed32

    def _mod_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[15] = ProtoBase.TYPE_sfixed32

    def _del_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 15 in self._cache:
            del self._cache[15]
        if 15 in self._mods:
            del self._mods[15]
        self._buf_del(15)

    _pb_field_name_15 = "n"

    n = property(_get_n, _set_n, _del_n)

    @property
    def n__exists(self):
        return 15 in self._mods or self._buf_exists(15)

    @property
    def n__type(self):
        return ProtoBase.TYPE_sfixed32

    def _finalize_n(cls):
        if is_string(ProtoBase.TYPE_sfixed32):
            cls._pbf_strings.append(15)
        elif _PB_type(ProtoBase.TYPE_sfixed32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_sfixed32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_sfixed32.pb_subtype):
                cls._pbf_strings.append(15)

    _pbf_finalizers.append(_finalize_n)


    def _get_o(self):
        if 16 in self._cache:
            r = self._cache[16]
        else:
            r = self._buf_get(16, ProtoBase.TYPE_float, 'o')
            self._cache[16] = r
        return r

    def _establish_parentage_o(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_o), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_o
                v._pbf_establish_parent_callback = self._establish_parentage_o

    def _set_o(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_o(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field o"
            raise ProtoValueError(list_assign_error)
        self._cache[16] = v
        self._mods[16] = ProtoBase.TYPE_float

    def _mod_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[16] = ProtoBase.TYPE_float

    def _del_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 16 in self._cache:
            del self._cache[16]
        if 16 in self._mods:
            del self._mods[16]
        self._buf_del(16)

    _pb_field_name_16 = "o"

    o = property(_get_o, _set_o, _del_o)

    @property
    def o__exists(self):
        return 16 in self._mods or self._buf_exists(16)

    @property
    def o__type(self):
        return ProtoBase.TYPE_float

    def _finalize_o(cls):
        if is_string(ProtoBase.TYPE_float):
            cls._pbf_strings.append(16)
        elif _PB_type(ProtoBase.TYPE_float) is _PB_type:
            assert issubclass(ProtoBase.TYPE_float, RepeatedSequence)
            if is_string(ProtoBase.TYPE_float.pb_subtype):
                cls._pbf_strings.append(16)

    _pbf_finalizers.append(_finalize_o)


    def _get_msg(self):
        if 17 in self._cache:
            r = self._cache[17]
        else:
            r = self._buf_get(17, Test.TYPE_Foo, 'msg')
            self._cache[17] = r
        return r

    def _establish_parentage_msg(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_msg), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_msg
                v._pbf_establish_parent_callback = self._establish_parentage_msg

    def _set_msg(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_msg(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field msg"
            raise ProtoValueError(list_assign_error)
        self._cache[17] = v
        self._mods[17] = Test.TYPE_Foo

    def _mod_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[17] = Test.TYPE_Foo

    def _del_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 17 in self._cache:
            del self._cache[17]
        if 17 in self._mods:
            del self._mods[17]
        self._buf_del(17)

    _pb_field_name_17 = "msg"

    msg = property(_get_msg, _set_msg, _del_msg)

    @property
    def msg__exists(self):
        return 17 in self._mods or self._buf_exists(17)

    @property
    def msg__type(self):
        return Test.TYPE_Foo

    def _finalize_msg(cls):
        if is_string(Test.TYPE_Foo):
            cls._pbf_strings.append(17)
        elif _PB_type(Test.TYPE_Foo) is _PB_type:
            assert issubclass(Test.TYPE_Foo, RepeatedSequence)
            if is_string(Test.TYPE_Foo.pb_subtype):
                cls._pbf_strings.append(17)

    _pbf_finalizers.append(_finalize_msg)


    def _get_yn(self):
        if 18 in self._cache:
            r = self._cache[18]
        else:
            r = self._buf_get(18, ProtoBase.TYPE_bool, 'yn')
            self._cache[18] = r
        return r

    def _establish_parentage_yn(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_yn), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_yn
                v._pbf_establish_parent_callback = self._establish_parentage_yn

    def _set_yn(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_yn(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field yn"
            raise ProtoValueError(list_assign_error)
        self._cache[18] = v
        self._mods[18] = ProtoBase.TYPE_bool

    def _mod_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[18] = ProtoBase.TYPE_bool

    def _del_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 18 in self._cache:
            del self._cache[18]
        if 18 in self._mods:
            del self._mods[18]
        self._buf_del(18)

    _pb_field_name_18 = "yn"

    yn = property(_get_yn, _set_yn, _del_yn)

    @property
    def yn__exists(self):
        return 18 in self._mods or self._buf_exists(18)

    @property
    def yn__type(self):
        return ProtoBase.TYPE_bool

    def _finalize_yn(cls):
        if is_string(ProtoBase.TYPE_bool):
            cls._pbf_strings.append(18)
        elif _PB_type(ProtoBase.TYPE_bool) is _PB_type:
            assert issubclass(ProtoBase.TYPE_bool, RepeatedSequence)
            if is_string(ProtoBase.TYPE_bool.pb_subtype):
                cls._pbf_strings.append(18)

    _pbf_finalizers.append(_finalize_yn)


    def _get_cls(self):
        if 19 in self._cache:
            r = self._cache[19]
        else:
            r = self._buf_get(19, Test.TYPE_AirplaneClass, 'cls')
            self._cache[19] = r
        return r

    def _establish_parentage_cls(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_cls), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_cls
                v._pbf_establish_parent_callback = self._establish_parentage_cls

    def _set_cls(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_cls(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field cls"
            raise ProtoValueError(list_assign_error)
        self._cache[19] = v
        self._mods[19] = Test.TYPE_AirplaneClass

    def _mod_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[19] = Test.TYPE_AirplaneClass

    def _del_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 19 in self._cache:
            del self._cache[19]
        if 19 in self._mods:
            del self._mods[19]
        self._buf_del(19)

    _pb_field_name_19 = "cls"

    cls = property(_get_cls, _set_cls, _del_cls)

    @property
    def cls__exists(self):
        return 19 in self._mods or self._buf_exists(19)

    @property
    def cls__type(self):
        return Test.TYPE_AirplaneClass

    def _finalize_cls(cls):
        if is_string(Test.TYPE_AirplaneClass):
            cls._pbf_strings.append(19)
        elif _PB_type(Test.TYPE_AirplaneClass) is _PB_type:
            assert issubclass(Test.TYPE_AirplaneClass, RepeatedSequence)
            if is_string(Test.TYPE_AirplaneClass.pb_subtype):
                cls._pbf_strings.append(19)

    _pbf_finalizers.append(_finalize_cls)


    def _get_p(self):
        if 21 in self._cache:
            r = self._cache[21]
        else:
            try:
                r = self._buf_get(21, ProtoBase.TYPE_uint32, 'p')
            except:
                r = 13
            self._cache[21] = r
        return r

    def _establish_parentage_p(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_p), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_p
                v._pbf_establish_parent_callback = self._establish_parentage_p

    def _set_p(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_p(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field p"
            raise ProtoValueError(list_assign_error)
        self._cache[21] = v
        self._mods[21] = ProtoBase.TYPE_uint32

    def _mod_p(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[21] = ProtoBase.TYPE_uint32

    def _del_p(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 21 in self._cache:
            del self._cache[21]
        if 21 in self._mods:
            del self._mods[21]
        self._buf_del(21)

    _pb_field_name_21 = "p"

    p = property(_get_p, _set_p, _del_p)

    @property
    def p__exists(self):
        return 21 in self._mods or self._buf_exists(21)

    @property
    def p__type(self):
        return ProtoBase.TYPE_uint32

    def _finalize_p(cls):
        if is_string(ProtoBase.TYPE_uint32):
            cls._pbf_strings.append(21)
        elif _PB_type(ProtoBase.TYPE_uint32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_uint32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_uint32.pb_subtype):
                cls._pbf_strings.append(21)

    _pbf_finalizers.append(_finalize_p)


    def _get_q(self):
        if 22 in self._cache:
            r = self._cache[22]
        else:
            try:
                r = self._buf_get(22, ProtoBase.TYPE_float, 'q')
            except:
                r = 23.4
            self._cache[22] = r
        return r

    def _establish_parentage_q(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_q), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_q
                v._pbf_establish_parent_callback = self._establish_parentage_q

    def _set_q(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_q(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field q"
            raise ProtoValueError(list_assign_error)
        self._cache[22] = v
        self._mods[22] = ProtoBase.TYPE_float

    def _mod_q(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[22] = ProtoBase.TYPE_float

    def _del_q(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 22 in self._cache:
            del self._cache[22]
        if 22 in self._mods:
            del self._mods[22]
        self._buf_del(22)

    _pb_field_name_22 = "q"

    q = property(_get_q, _set_q, _del_q)

    @property
    def q__exists(self):
        return 22 in self._mods or self._buf_exists(22)

    @property
    def q__type(self):
        return ProtoBase.TYPE_float

    def _finalize_q(cls):
        if is_string(ProtoBase.TYPE_float):
            cls._pbf_strings.append(22)
        elif _PB_type(ProtoBase.TYPE_float) is _PB_type:
            assert issubclass(ProtoBase.TYPE_float, RepeatedSequence)
            if is_string(ProtoBase.TYPE_float.pb_subtype):
                cls._pbf_strings.append(22)

    _pbf_finalizers.append(_finalize_q)


    def _get_r(self):
        if 23 in self._cache:
            r = self._cache[23]
        else:
            try:
                r = self._buf_get(23, ProtoBase.TYPE_string, 'r')
            except:
                r = "cats"
            self._cache[23] = r
        return r

    def _establish_parentage_r(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r
                v._pbf_establish_parent_callback = self._establish_parentage_r

    def _set_r(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r"
            raise ProtoValueError(list_assign_error)
        self._cache[23] = v
        self._mods[23] = ProtoBase.TYPE_string

    def _mod_r(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[23] = ProtoBase.TYPE_string

    def _del_r(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 23 in self._cache:
            del self._cache[23]
        if 23 in self._mods:
            del self._mods[23]
        self._buf_del(23)

    _pb_field_name_23 = "r"

    r = property(_get_r, _set_r, _del_r)

    @property
    def r__exists(self):
        return 23 in self._mods or self._buf_exists(23)

    @property
    def r__type(self):
        return ProtoBase.TYPE_string

    def _finalize_r(cls):
        if is_string(ProtoBase.TYPE_string):
            cls._pbf_strings.append(23)
        elif _PB_type(ProtoBase.TYPE_string) is _PB_type:
            assert issubclass(ProtoBase.TYPE_string, RepeatedSequence)
            if is_string(ProtoBase.TYPE_string.pb_subtype):
                cls._pbf_strings.append(23)

    _pbf_finalizers.append(_finalize_r)


    class Repeated_r_sha1(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_string
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_sha1 = Repeated_r_sha1


    def _get_r_sha1(self):
        if 31 in self._cache:
            r = self._cache[31]
        else:
            r = self._buf_get(31, self.TYPE_Repeated_r_sha1, 'r_sha1')
            self._cache[31] = r
        return r

    def _establish_parentage_r_sha1(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_sha1), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_sha1
                v._pbf_establish_parent_callback = self._establish_parentage_r_sha1

    def _set_r_sha1(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_sha1(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_sha1"
            raise ProtoValueError(list_assign_error)
        self._cache[31] = v
        self._mods[31] = self.TYPE_Repeated_r_sha1

    def _mod_r_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[31] = self.TYPE_Repeated_r_sha1

    def _del_r_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 31 in self._cache:
            del self._cache[31]
        if 31 in self._mods:
            del self._mods[31]
        self._buf_del(31)

    _pb_field_name_31 = "r_sha1"

    r_sha1 = property(_get_r_sha1, _set_r_sha1, _del_r_sha1)

    @property
    def r_sha1__exists(self):
        return 31 in self._mods or self._buf_exists(31)

    @property
    def r_sha1__type(self):
        return self.TYPE_Repeated_r_sha1

    def _finalize_r_sha1(cls):
        if is_string(cls.TYPE_Repeated_r_sha1):
            cls._pbf_strings.append(31)
        elif _PB_type(cls.TYPE_Repeated_r_sha1) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_sha1, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_sha1.pb_subtype):
                cls._pbf_strings.append(31)

    _pbf_finalizers.append(_finalize_r_sha1)


    class Repeated_r_a(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_uint32
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_a = Repeated_r_a


    def _get_r_a(self):
        if 32 in self._cache:
            r = self._cache[32]
        else:
            r = self._buf_get(32, self.TYPE_Repeated_r_a, 'r_a')
            self._cache[32] = r
        return r

    def _establish_parentage_r_a(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_a), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_a
                v._pbf_establish_parent_callback = self._establish_parentage_r_a

    def _set_r_a(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_a(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_a"
            raise ProtoValueError(list_assign_error)
        self._cache[32] = v
        self._mods[32] = self.TYPE_Repeated_r_a

    def _mod_r_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[32] = self.TYPE_Repeated_r_a

    def _del_r_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 32 in self._cache:
            del self._cache[32]
        if 32 in self._mods:
            del self._mods[32]
        self._buf_del(32)

    _pb_field_name_32 = "r_a"

    r_a = property(_get_r_a, _set_r_a, _del_r_a)

    @property
    def r_a__exists(self):
        return 32 in self._mods or self._buf_exists(32)

    @property
    def r_a__type(self):
        return self.TYPE_Repeated_r_a

    def _finalize_r_a(cls):
        if is_string(cls.TYPE_Repeated_r_a):
            cls._pbf_strings.append(32)
        elif _PB_type(cls.TYPE_Repeated_r_a) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_a, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_a.pb_subtype):
                cls._pbf_strings.append(32)

    _pbf_finalizers.append(_finalize_r_a)


    class Repeated_r_b(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_int32
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_b = Repeated_r_b


    def _get_r_b(self):
        if 33 in self._cache:
            r = self._cache[33]
        else:
            r = self._buf_get(33, self.TYPE_Repeated_r_b, 'r_b')
            self._cache[33] = r
        return r

    def _establish_parentage_r_b(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_b), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_b
                v._pbf_establish_parent_callback = self._establish_parentage_r_b

    def _set_r_b(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_b(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_b"
            raise ProtoValueError(list_assign_error)
        self._cache[33] = v
        self._mods[33] = self.TYPE_Repeated_r_b

    def _mod_r_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[33] = self.TYPE_Repeated_r_b

    def _del_r_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 33 in self._cache:
            del self._cache[33]
        if 33 in self._mods:
            del self._mods[33]
        self._buf_del(33)

    _pb_field_name_33 = "r_b"

    r_b = property(_get_r_b, _set_r_b, _del_r_b)

    @property
    def r_b__exists(self):
        return 33 in self._mods or self._buf_exists(33)

    @property
    def r_b__type(self):
        return self.TYPE_Repeated_r_b

    def _finalize_r_b(cls):
        if is_string(cls.TYPE_Repeated_r_b):
            cls._pbf_strings.append(33)
        elif _PB_type(cls.TYPE_Repeated_r_b) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_b, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_b.pb_subtype):
                cls._pbf_strings.append(33)

    _pbf_finalizers.append(_finalize_r_b)


    class Repeated_r_c(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_sint32
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_c = Repeated_r_c


    def _get_r_c(self):
        if 34 in self._cache:
            r = self._cache[34]
        else:
            r = self._buf_get(34, self.TYPE_Repeated_r_c, 'r_c')
            self._cache[34] = r
        return r

    def _establish_parentage_r_c(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_c), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_c
                v._pbf_establish_parent_callback = self._establish_parentage_r_c

    def _set_r_c(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_c(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_c"
            raise ProtoValueError(list_assign_error)
        self._cache[34] = v
        self._mods[34] = self.TYPE_Repeated_r_c

    def _mod_r_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[34] = self.TYPE_Repeated_r_c

    def _del_r_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 34 in self._cache:
            del self._cache[34]
        if 34 in self._mods:
            del self._mods[34]
        self._buf_del(34)

    _pb_field_name_34 = "r_c"

    r_c = property(_get_r_c, _set_r_c, _del_r_c)

    @property
    def r_c__exists(self):
        return 34 in self._mods or self._buf_exists(34)

    @property
    def r_c__type(self):
        return self.TYPE_Repeated_r_c

    def _finalize_r_c(cls):
        if is_string(cls.TYPE_Repeated_r_c):
            cls._pbf_strings.append(34)
        elif _PB_type(cls.TYPE_Repeated_r_c) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_c, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_c.pb_subtype):
                cls._pbf_strings.append(34)

    _pbf_finalizers.append(_finalize_r_c)


    class Repeated_r_d(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_uint64
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_d = Repeated_r_d


    def _get_r_d(self):
        if 35 in self._cache:
            r = self._cache[35]
        else:
            r = self._buf_get(35, self.TYPE_Repeated_r_d, 'r_d')
            self._cache[35] = r
        return r

    def _establish_parentage_r_d(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_d), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_d
                v._pbf_establish_parent_callback = self._establish_parentage_r_d

    def _set_r_d(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_d(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_d"
            raise ProtoValueError(list_assign_error)
        self._cache[35] = v
        self._mods[35] = self.TYPE_Repeated_r_d

    def _mod_r_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[35] = self.TYPE_Repeated_r_d

    def _del_r_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 35 in self._cache:
            del self._cache[35]
        if 35 in self._mods:
            del self._mods[35]
        self._buf_del(35)

    _pb_field_name_35 = "r_d"

    r_d = property(_get_r_d, _set_r_d, _del_r_d)

    @property
    def r_d__exists(self):
        return 35 in self._mods or self._buf_exists(35)

    @property
    def r_d__type(self):
        return self.TYPE_Repeated_r_d

    def _finalize_r_d(cls):
        if is_string(cls.TYPE_Repeated_r_d):
            cls._pbf_strings.append(35)
        elif _PB_type(cls.TYPE_Repeated_r_d) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_d, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_d.pb_subtype):
                cls._pbf_strings.append(35)

    _pbf_finalizers.append(_finalize_r_d)


    class Repeated_r_e(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_int64
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_e = Repeated_r_e


    def _get_r_e(self):
        if 36 in self._cache:
            r = self._cache[36]
        else:
            r = self._buf_get(36, self.TYPE_Repeated_r_e, 'r_e')
            self._cache[36] = r
        return r

    def _establish_parentage_r_e(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_e), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_e
                v._pbf_establish_parent_callback = self._establish_parentage_r_e

    def _set_r_e(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_e(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_e"
            raise ProtoValueError(list_assign_error)
        self._cache[36] = v
        self._mods[36] = self.TYPE_Repeated_r_e

    def _mod_r_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[36] = self.TYPE_Repeated_r_e

    def _del_r_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 36 in self._cache:
            del self._cache[36]
        if 36 in self._mods:
            del self._mods[36]
        self._buf_del(36)

    _pb_field_name_36 = "r_e"

    r_e = property(_get_r_e, _set_r_e, _del_r_e)

    @property
    def r_e__exists(self):
        return 36 in self._mods or self._buf_exists(36)

    @property
    def r_e__type(self):
        return self.TYPE_Repeated_r_e

    def _finalize_r_e(cls):
        if is_string(cls.TYPE_Repeated_r_e):
            cls._pbf_strings.append(36)
        elif _PB_type(cls.TYPE_Repeated_r_e) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_e, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_e.pb_subtype):
                cls._pbf_strings.append(36)

    _pbf_finalizers.append(_finalize_r_e)


    class Repeated_r_f(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_sint64
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_f = Repeated_r_f


    def _get_r_f(self):
        if 37 in self._cache:
            r = self._cache[37]
        else:
            r = self._buf_get(37, self.TYPE_Repeated_r_f, 'r_f')
            self._cache[37] = r
        return r

    def _establish_parentage_r_f(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_f), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_f
                v._pbf_establish_parent_callback = self._establish_parentage_r_f

    def _set_r_f(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_f(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_f"
            raise ProtoValueError(list_assign_error)
        self._cache[37] = v
        self._mods[37] = self.TYPE_Repeated_r_f

    def _mod_r_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[37] = self.TYPE_Repeated_r_f

    def _del_r_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 37 in self._cache:
            del self._cache[37]
        if 37 in self._mods:
            del self._mods[37]
        self._buf_del(37)

    _pb_field_name_37 = "r_f"

    r_f = property(_get_r_f, _set_r_f, _del_r_f)

    @property
    def r_f__exists(self):
        return 37 in self._mods or self._buf_exists(37)

    @property
    def r_f__type(self):
        return self.TYPE_Repeated_r_f

    def _finalize_r_f(cls):
        if is_string(cls.TYPE_Repeated_r_f):
            cls._pbf_strings.append(37)
        elif _PB_type(cls.TYPE_Repeated_r_f) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_f, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_f.pb_subtype):
                cls._pbf_strings.append(37)

    _pbf_finalizers.append(_finalize_r_f)


    class Repeated_r_g(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_fixed64
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_g = Repeated_r_g


    def _get_r_g(self):
        if 39 in self._cache:
            r = self._cache[39]
        else:
            r = self._buf_get(39, self.TYPE_Repeated_r_g, 'r_g')
            self._cache[39] = r
        return r

    def _establish_parentage_r_g(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_g), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_g
                v._pbf_establish_parent_callback = self._establish_parentage_r_g

    def _set_r_g(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_g(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_g"
            raise ProtoValueError(list_assign_error)
        self._cache[39] = v
        self._mods[39] = self.TYPE_Repeated_r_g

    def _mod_r_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[39] = self.TYPE_Repeated_r_g

    def _del_r_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 39 in self._cache:
            del self._cache[39]
        if 39 in self._mods:
            del self._mods[39]
        self._buf_del(39)

    _pb_field_name_39 = "r_g"

    r_g = property(_get_r_g, _set_r_g, _del_r_g)

    @property
    def r_g__exists(self):
        return 39 in self._mods or self._buf_exists(39)

    @property
    def r_g__type(self):
        return self.TYPE_Repeated_r_g

    def _finalize_r_g(cls):
        if is_string(cls.TYPE_Repeated_r_g):
            cls._pbf_strings.append(39)
        elif _PB_type(cls.TYPE_Repeated_r_g) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_g, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_g.pb_subtype):
                cls._pbf_strings.append(39)

    _pbf_finalizers.append(_finalize_r_g)


    class Repeated_r_h(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_sfixed64
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_h = Repeated_r_h


    def _get_r_h(self):
        if 40 in self._cache:
            r = self._cache[40]
        else:
            r = self._buf_get(40, self.TYPE_Repeated_r_h, 'r_h')
            self._cache[40] = r
        return r

    def _establish_parentage_r_h(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_h), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_h
                v._pbf_establish_parent_callback = self._establish_parentage_r_h

    def _set_r_h(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_h(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_h"
            raise ProtoValueError(list_assign_error)
        self._cache[40] = v
        self._mods[40] = self.TYPE_Repeated_r_h

    def _mod_r_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[40] = self.TYPE_Repeated_r_h

    def _del_r_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 40 in self._cache:
            del self._cache[40]
        if 40 in self._mods:
            del self._mods[40]
        self._buf_del(40)

    _pb_field_name_40 = "r_h"

    r_h = property(_get_r_h, _set_r_h, _del_r_h)

    @property
    def r_h__exists(self):
        return 40 in self._mods or self._buf_exists(40)

    @property
    def r_h__type(self):
        return self.TYPE_Repeated_r_h

    def _finalize_r_h(cls):
        if is_string(cls.TYPE_Repeated_r_h):
            cls._pbf_strings.append(40)
        elif _PB_type(cls.TYPE_Repeated_r_h) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_h, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_h.pb_subtype):
                cls._pbf_strings.append(40)

    _pbf_finalizers.append(_finalize_r_h)


    class Repeated_r_i(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_sfixed64
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_i = Repeated_r_i


    def _get_r_i(self):
        if 41 in self._cache:
            r = self._cache[41]
        else:
            r = self._buf_get(41, self.TYPE_Repeated_r_i, 'r_i')
            self._cache[41] = r
        return r

    def _establish_parentage_r_i(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_i), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_i
                v._pbf_establish_parent_callback = self._establish_parentage_r_i

    def _set_r_i(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_i(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_i"
            raise ProtoValueError(list_assign_error)
        self._cache[41] = v
        self._mods[41] = self.TYPE_Repeated_r_i

    def _mod_r_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[41] = self.TYPE_Repeated_r_i

    def _del_r_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 41 in self._cache:
            del self._cache[41]
        if 41 in self._mods:
            del self._mods[41]
        self._buf_del(41)

    _pb_field_name_41 = "r_i"

    r_i = property(_get_r_i, _set_r_i, _del_r_i)

    @property
    def r_i__exists(self):
        return 41 in self._mods or self._buf_exists(41)

    @property
    def r_i__type(self):
        return self.TYPE_Repeated_r_i

    def _finalize_r_i(cls):
        if is_string(cls.TYPE_Repeated_r_i):
            cls._pbf_strings.append(41)
        elif _PB_type(cls.TYPE_Repeated_r_i) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_i, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_i.pb_subtype):
                cls._pbf_strings.append(41)

    _pbf_finalizers.append(_finalize_r_i)


    class Repeated_r_k(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_double
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_k = Repeated_r_k


    def _get_r_k(self):
        if 42 in self._cache:
            r = self._cache[42]
        else:
            r = self._buf_get(42, self.TYPE_Repeated_r_k, 'r_k')
            self._cache[42] = r
        return r

    def _establish_parentage_r_k(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_k), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_k
                v._pbf_establish_parent_callback = self._establish_parentage_r_k

    def _set_r_k(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_k(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_k"
            raise ProtoValueError(list_assign_error)
        self._cache[42] = v
        self._mods[42] = self.TYPE_Repeated_r_k

    def _mod_r_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[42] = self.TYPE_Repeated_r_k

    def _del_r_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 42 in self._cache:
            del self._cache[42]
        if 42 in self._mods:
            del self._mods[42]
        self._buf_del(42)

    _pb_field_name_42 = "r_k"

    r_k = property(_get_r_k, _set_r_k, _del_r_k)

    @property
    def r_k__exists(self):
        return 42 in self._mods or self._buf_exists(42)

    @property
    def r_k__type(self):
        return self.TYPE_Repeated_r_k

    def _finalize_r_k(cls):
        if is_string(cls.TYPE_Repeated_r_k):
            cls._pbf_strings.append(42)
        elif _PB_type(cls.TYPE_Repeated_r_k) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_k, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_k.pb_subtype):
                cls._pbf_strings.append(42)

    _pbf_finalizers.append(_finalize_r_k)


    class Repeated_r_l(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_fixed32
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_l = Repeated_r_l


    def _get_r_l(self):
        if 43 in self._cache:
            r = self._cache[43]
        else:
            r = self._buf_get(43, self.TYPE_Repeated_r_l, 'r_l')
            self._cache[43] = r
        return r

    def _establish_parentage_r_l(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_l), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_l
                v._pbf_establish_parent_callback = self._establish_parentage_r_l

    def _set_r_l(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_l(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_l"
            raise ProtoValueError(list_assign_error)
        self._cache[43] = v
        self._mods[43] = self.TYPE_Repeated_r_l

    def _mod_r_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[43] = self.TYPE_Repeated_r_l

    def _del_r_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 43 in self._cache:
            del self._cache[43]
        if 43 in self._mods:
            del self._mods[43]
        self._buf_del(43)

    _pb_field_name_43 = "r_l"

    r_l = property(_get_r_l, _set_r_l, _del_r_l)

    @property
    def r_l__exists(self):
        return 43 in self._mods or self._buf_exists(43)

    @property
    def r_l__type(self):
        return self.TYPE_Repeated_r_l

    def _finalize_r_l(cls):
        if is_string(cls.TYPE_Repeated_r_l):
            cls._pbf_strings.append(43)
        elif _PB_type(cls.TYPE_Repeated_r_l) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_l, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_l.pb_subtype):
                cls._pbf_strings.append(43)

    _pbf_finalizers.append(_finalize_r_l)


    class Repeated_r_m(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_sfixed32
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_m = Repeated_r_m


    def _get_r_m(self):
        if 44 in self._cache:
            r = self._cache[44]
        else:
            r = self._buf_get(44, self.TYPE_Repeated_r_m, 'r_m')
            self._cache[44] = r
        return r

    def _establish_parentage_r_m(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_m), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_m
                v._pbf_establish_parent_callback = self._establish_parentage_r_m

    def _set_r_m(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_m(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_m"
            raise ProtoValueError(list_assign_error)
        self._cache[44] = v
        self._mods[44] = self.TYPE_Repeated_r_m

    def _mod_r_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[44] = self.TYPE_Repeated_r_m

    def _del_r_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 44 in self._cache:
            del self._cache[44]
        if 44 in self._mods:
            del self._mods[44]
        self._buf_del(44)

    _pb_field_name_44 = "r_m"

    r_m = property(_get_r_m, _set_r_m, _del_r_m)

    @property
    def r_m__exists(self):
        return 44 in self._mods or self._buf_exists(44)

    @property
    def r_m__type(self):
        return self.TYPE_Repeated_r_m

    def _finalize_r_m(cls):
        if is_string(cls.TYPE_Repeated_r_m):
            cls._pbf_strings.append(44)
        elif _PB_type(cls.TYPE_Repeated_r_m) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_m, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_m.pb_subtype):
                cls._pbf_strings.append(44)

    _pbf_finalizers.append(_finalize_r_m)


    class Repeated_r_n(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_sfixed32
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_n = Repeated_r_n


    def _get_r_n(self):
        if 45 in self._cache:
            r = self._cache[45]
        else:
            r = self._buf_get(45, self.TYPE_Repeated_r_n, 'r_n')
            self._cache[45] = r
        return r

    def _establish_parentage_r_n(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_n), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_n
                v._pbf_establish_parent_callback = self._establish_parentage_r_n

    def _set_r_n(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_n(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_n"
            raise ProtoValueError(list_assign_error)
        self._cache[45] = v
        self._mods[45] = self.TYPE_Repeated_r_n

    def _mod_r_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[45] = self.TYPE_Repeated_r_n

    def _del_r_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 45 in self._cache:
            del self._cache[45]
        if 45 in self._mods:
            del self._mods[45]
        self._buf_del(45)

    _pb_field_name_45 = "r_n"

    r_n = property(_get_r_n, _set_r_n, _del_r_n)

    @property
    def r_n__exists(self):
        return 45 in self._mods or self._buf_exists(45)

    @property
    def r_n__type(self):
        return self.TYPE_Repeated_r_n

    def _finalize_r_n(cls):
        if is_string(cls.TYPE_Repeated_r_n):
            cls._pbf_strings.append(45)
        elif _PB_type(cls.TYPE_Repeated_r_n) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_n, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_n.pb_subtype):
                cls._pbf_strings.append(45)

    _pbf_finalizers.append(_finalize_r_n)


    class Repeated_r_o(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_float
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_o = Repeated_r_o


    def _get_r_o(self):
        if 46 in self._cache:
            r = self._cache[46]
        else:
            r = self._buf_get(46, self.TYPE_Repeated_r_o, 'r_o')
            self._cache[46] = r
        return r

    def _establish_parentage_r_o(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_o), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_o
                v._pbf_establish_parent_callback = self._establish_parentage_r_o

    def _set_r_o(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_o(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_o"
            raise ProtoValueError(list_assign_error)
        self._cache[46] = v
        self._mods[46] = self.TYPE_Repeated_r_o

    def _mod_r_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[46] = self.TYPE_Repeated_r_o

    def _del_r_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 46 in self._cache:
            del self._cache[46]
        if 46 in self._mods:
            del self._mods[46]
        self._buf_del(46)

    _pb_field_name_46 = "r_o"

    r_o = property(_get_r_o, _set_r_o, _del_r_o)

    @property
    def r_o__exists(self):
        return 46 in self._mods or self._buf_exists(46)

    @property
    def r_o__type(self):
        return self.TYPE_Repeated_r_o

    def _finalize_r_o(cls):
        if is_string(cls.TYPE_Repeated_r_o):
            cls._pbf_strings.append(46)
        elif _PB_type(cls.TYPE_Repeated_r_o) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_o, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_o.pb_subtype):
                cls._pbf_strings.append(46)

    _pbf_finalizers.append(_finalize_r_o)


    class Repeated_r_msg(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return Test.TYPE_Foo
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_msg = Repeated_r_msg


    @property
    def r_msg__stream(self):
        if 47 in self._cache:
            def acc(v):
                v_ = lambda: v
                return v_
            return [acc(v) for v in self._cache[47]]
        return self._get_repeated(47, self.TYPE_Repeated_r_msg, "r_msg", lazy=True)

    def r_msg__fast_append(self, value):
        self._append_to_repeated(47, self.TYPE_Repeated_r_msg, value)

    def _get_r_msg(self):
        if 47 in self._cache:
            r = self._cache[47]
        else:
            r = self._buf_get(47, self.TYPE_Repeated_r_msg, 'r_msg')
            self._cache[47] = r
        return r

    def _establish_parentage_r_msg(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_msg), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_msg
                v._pbf_establish_parent_callback = self._establish_parentage_r_msg

    def _set_r_msg(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_msg(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_msg"
            raise ProtoValueError(list_assign_error)
        self._cache[47] = v
        self._mods[47] = self.TYPE_Repeated_r_msg

    def _mod_r_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[47] = self.TYPE_Repeated_r_msg

    def _del_r_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 47 in self._cache:
            del self._cache[47]
        if 47 in self._mods:
            del self._mods[47]
        self._buf_del(47)

    _pb_field_name_47 = "r_msg"

    r_msg = property(_get_r_msg, _set_r_msg, _del_r_msg)

    @property
    def r_msg__exists(self):
        return 47 in self._mods or self._buf_exists(47)

    @property
    def r_msg__type(self):
        return self.TYPE_Repeated_r_msg

    def _finalize_r_msg(cls):
        if is_string(cls.TYPE_Repeated_r_msg):
            cls._pbf_strings.append(47)
        elif _PB_type(cls.TYPE_Repeated_r_msg) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_msg, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_msg.pb_subtype):
                cls._pbf_strings.append(47)

    _pbf_finalizers.append(_finalize_r_msg)


    class Repeated_r_yn(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return ProtoBase.TYPE_bool
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_yn = Repeated_r_yn


    def _get_r_yn(self):
        if 48 in self._cache:
            r = self._cache[48]
        else:
            r = self._buf_get(48, self.TYPE_Repeated_r_yn, 'r_yn')
            self._cache[48] = r
        return r

    def _establish_parentage_r_yn(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_yn), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_yn
                v._pbf_establish_parent_callback = self._establish_parentage_r_yn

    def _set_r_yn(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_yn(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_yn"
            raise ProtoValueError(list_assign_error)
        self._cache[48] = v
        self._mods[48] = self.TYPE_Repeated_r_yn

    def _mod_r_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[48] = self.TYPE_Repeated_r_yn

    def _del_r_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 48 in self._cache:
            del self._cache[48]
        if 48 in self._mods:
            del self._mods[48]
        self._buf_del(48)

    _pb_field_name_48 = "r_yn"

    r_yn = property(_get_r_yn, _set_r_yn, _del_r_yn)

    @property
    def r_yn__exists(self):
        return 48 in self._mods or self._buf_exists(48)

    @property
    def r_yn__type(self):
        return self.TYPE_Repeated_r_yn

    def _finalize_r_yn(cls):
        if is_string(cls.TYPE_Repeated_r_yn):
            cls._pbf_strings.append(48)
        elif _PB_type(cls.TYPE_Repeated_r_yn) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_yn, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_yn.pb_subtype):
                cls._pbf_strings.append(48)

    _pbf_finalizers.append(_finalize_r_yn)


    class Repeated_r_cls(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return Test.TYPE_AirplaneClass
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_cls = Repeated_r_cls


    @property
    def r_cls__stream(self):
        if 49 in self._cache:
            def acc(v):
                v_ = lambda: v
                return v_
            return [acc(v) for v in self._cache[49]]
        return self._get_repeated(49, self.TYPE_Repeated_r_cls, "r_cls", lazy=True)

    def r_cls__fast_append(self, value):
        self._append_to_repeated(49, self.TYPE_Repeated_r_cls, value)

    def _get_r_cls(self):
        if 49 in self._cache:
            r = self._cache[49]
        else:
            r = self._buf_get(49, self.TYPE_Repeated_r_cls, 'r_cls')
            self._cache[49] = r
        return r

    def _establish_parentage_r_cls(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_cls), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_cls
                v._pbf_establish_parent_callback = self._establish_parentage_r_cls

    def _set_r_cls(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_cls(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_cls"
            raise ProtoValueError(list_assign_error)
        self._cache[49] = v
        self._mods[49] = self.TYPE_Repeated_r_cls

    def _mod_r_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[49] = self.TYPE_Repeated_r_cls

    def _del_r_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 49 in self._cache:
            del self._cache[49]
        if 49 in self._mods:
            del self._mods[49]
        self._buf_del(49)

    _pb_field_name_49 = "r_cls"

    r_cls = property(_get_r_cls, _set_r_cls, _del_r_cls)

    @property
    def r_cls__exists(self):
        return 49 in self._mods or self._buf_exists(49)

    @property
    def r_cls__type(self):
        return self.TYPE_Repeated_r_cls

    def _finalize_r_cls(cls):
        if is_string(cls.TYPE_Repeated_r_cls):
            cls._pbf_strings.append(49)
        elif _PB_type(cls.TYPE_Repeated_r_cls) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_cls, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_cls.pb_subtype):
                cls._pbf_strings.append(49)

    _pbf_finalizers.append(_finalize_r_cls)


    def _get_req_a(self):
        if 50 in self._cache:
            r = self._cache[50]
        else:
            r = self._buf_get(50, ProtoBase.TYPE_uint32, 'req_a')
            self._cache[50] = r
        return r

    def _establish_parentage_req_a(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_req_a), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_req_a
                v._pbf_establish_parent_callback = self._establish_parentage_req_a

    def _set_req_a(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_req_a(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field req_a"
            raise ProtoValueError(list_assign_error)
        self._cache[50] = v
        self._mods[50] = ProtoBase.TYPE_uint32

    def _mod_req_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[50] = ProtoBase.TYPE_uint32

    def _del_req_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 50 in self._cache:
            del self._cache[50]
        if 50 in self._mods:
            del self._mods[50]
        self._buf_del(50)

    _pb_field_name_50 = "req_a"

    req_a = property(_get_req_a, _set_req_a, _del_req_a)

    @property
    def req_a__exists(self):
        return 50 in self._mods or self._buf_exists(50)

    @property
    def req_a__type(self):
        return ProtoBase.TYPE_uint32

    def _finalize_req_a(cls):
        if is_string(ProtoBase.TYPE_uint32):
            cls._pbf_strings.append(50)
        elif _PB_type(ProtoBase.TYPE_uint32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_uint32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_uint32.pb_subtype):
                cls._pbf_strings.append(50)

    _pbf_finalizers.append(_finalize_req_a)


    def _get_req_b(self):
        if 51 in self._cache:
            r = self._cache[51]
        else:
            r = self._buf_get(51, ProtoBase.TYPE_int32, 'req_b')
            self._cache[51] = r
        return r

    def _establish_parentage_req_b(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_req_b), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_req_b
                v._pbf_establish_parent_callback = self._establish_parentage_req_b

    def _set_req_b(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_req_b(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field req_b"
            raise ProtoValueError(list_assign_error)
        self._cache[51] = v
        self._mods[51] = ProtoBase.TYPE_int32

    def _mod_req_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[51] = ProtoBase.TYPE_int32

    def _del_req_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 51 in self._cache:
            del self._cache[51]
        if 51 in self._mods:
            del self._mods[51]
        self._buf_del(51)

    _pb_field_name_51 = "req_b"

    req_b = property(_get_req_b, _set_req_b, _del_req_b)

    @property
    def req_b__exists(self):
        return 51 in self._mods or self._buf_exists(51)

    @property
    def req_b__type(self):
        return ProtoBase.TYPE_int32

    def _finalize_req_b(cls):
        if is_string(ProtoBase.TYPE_int32):
            cls._pbf_strings.append(51)
        elif _PB_type(ProtoBase.TYPE_int32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_int32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_int32.pb_subtype):
                cls._pbf_strings.append(51)

    _pbf_finalizers.append(_finalize_req_b)


    def _get_req_c(self):
        if 52 in self._cache:
            r = self._cache[52]
        else:
            r = self._buf_get(52, ProtoBase.TYPE_sint32, 'req_c')
            self._cache[52] = r
        return r

    def _establish_parentage_req_c(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_req_c), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_req_c
                v._pbf_establish_parent_callback = self._establish_parentage_req_c

    def _set_req_c(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_req_c(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field req_c"
            raise ProtoValueError(list_assign_error)
        self._cache[52] = v
        self._mods[52] = ProtoBase.TYPE_sint32

    def _mod_req_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[52] = ProtoBase.TYPE_sint32

    def _del_req_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 52 in self._cache:
            del self._cache[52]
        if 52 in self._mods:
            del self._mods[52]
        self._buf_del(52)

    _pb_field_name_52 = "req_c"

    req_c = property(_get_req_c, _set_req_c, _del_req_c)

    @property
    def req_c__exists(self):
        return 52 in self._mods or self._buf_exists(52)

    @property
    def req_c__type(self):
        return ProtoBase.TYPE_sint32

    def _finalize_req_c(cls):
        if is_string(ProtoBase.TYPE_sint32):
            cls._pbf_strings.append(52)
        elif _PB_type(ProtoBase.TYPE_sint32) is _PB_type:
            assert issubclass(ProtoBase.TYPE_sint32, RepeatedSequence)
            if is_string(ProtoBase.TYPE_sint32.pb_subtype):
                cls._pbf_strings.append(52)

    _pbf_finalizers.append(_finalize_req_c)


    def _get_secret(self):
        if 53 in self._cache:
            r = self._cache[53]
        else:
            r = self._buf_get(53, TYPE_Secret, 'secret')
            self._cache[53] = r
        return r

    def _establish_parentage_secret(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_secret), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_secret
                v._pbf_establish_parent_callback = self._establish_parentage_secret

    def _set_secret(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_secret(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field secret"
            raise ProtoValueError(list_assign_error)
        self._cache[53] = v
        self._mods[53] = TYPE_Secret

    def _mod_secret(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[53] = TYPE_Secret

    def _del_secret(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 53 in self._cache:
            del self._cache[53]
        if 53 in self._mods:
            del self._mods[53]
        self._buf_del(53)

    _pb_field_name_53 = "secret"

    secret = property(_get_secret, _set_secret, _del_secret)

    @property
    def secret__exists(self):
        return 53 in self._mods or self._buf_exists(53)

    @property
    def secret__type(self):
        return TYPE_Secret

    def _finalize_secret(cls):
        if is_string(TYPE_Secret):
            cls._pbf_strings.append(53)
        elif _PB_type(TYPE_Secret) is _PB_type:
            assert issubclass(TYPE_Secret, RepeatedSequence)
            if is_string(TYPE_Secret.pb_subtype):
                cls._pbf_strings.append(53)

    _pbf_finalizers.append(_finalize_secret)


    def _get_answer1(self):
        if 54 in self._cache:
            r = self._cache[54]
        else:
            try:
                r = self._buf_get(54, ProtoBase.TYPE_bool, 'answer1')
            except:
                r = True
            self._cache[54] = r
        return r

    def _establish_parentage_answer1(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_answer1), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_answer1
                v._pbf_establish_parent_callback = self._establish_parentage_answer1

    def _set_answer1(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_answer1(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field answer1"
            raise ProtoValueError(list_assign_error)
        self._cache[54] = v
        self._mods[54] = ProtoBase.TYPE_bool

    def _mod_answer1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[54] = ProtoBase.TYPE_bool

    def _del_answer1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 54 in self._cache:
            del self._cache[54]
        if 54 in self._mods:
            del self._mods[54]
        self._buf_del(54)

    _pb_field_name_54 = "answer1"

    answer1 = property(_get_answer1, _set_answer1, _del_answer1)

    @property
    def answer1__exists(self):
        return 54 in self._mods or self._buf_exists(54)

    @property
    def answer1__type(self):
        return ProtoBase.TYPE_bool

    def _finalize_answer1(cls):
        if is_string(ProtoBase.TYPE_bool):
            cls._pbf_strings.append(54)
        elif _PB_type(ProtoBase.TYPE_bool) is _PB_type:
            assert issubclass(ProtoBase.TYPE_bool, RepeatedSequence)
            if is_string(ProtoBase.TYPE_bool.pb_subtype):
                cls._pbf_strings.append(54)

    _pbf_finalizers.append(_finalize_answer1)


    def _get_answer2(self):
        if 55 in self._cache:
            r = self._cache[55]
        else:
            try:
                r = self._buf_get(55, ProtoBase.TYPE_bool, 'answer2')
            except:
                r = False
            self._cache[55] = r
        return r

    def _establish_parentage_answer2(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_answer2), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_answer2
                v._pbf_establish_parent_callback = self._establish_parentage_answer2

    def _set_answer2(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_answer2(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field answer2"
            raise ProtoValueError(list_assign_error)
        self._cache[55] = v
        self._mods[55] = ProtoBase.TYPE_bool

    def _mod_answer2(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[55] = ProtoBase.TYPE_bool

    def _del_answer2(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 55 in self._cache:
            del self._cache[55]
        if 55 in self._mods:
            del self._mods[55]
        self._buf_del(55)

    _pb_field_name_55 = "answer2"

    answer2 = property(_get_answer2, _set_answer2, _del_answer2)

    @property
    def answer2__exists(self):
        return 55 in self._mods or self._buf_exists(55)

    @property
    def answer2__type(self):
        return ProtoBase.TYPE_bool

    def _finalize_answer2(cls):
        if is_string(ProtoBase.TYPE_bool):
            cls._pbf_strings.append(55)
        elif _PB_type(ProtoBase.TYPE_bool) is _PB_type:
            assert issubclass(ProtoBase.TYPE_bool, RepeatedSequence)
            if is_string(ProtoBase.TYPE_bool.pb_subtype):
                cls._pbf_strings.append(55)

    _pbf_finalizers.append(_finalize_answer2)


    class Repeated_r_secret(RepeatedSequence):
        class pb_subtype(object):
            def __get__(self, instance, cls):
                return TYPE_Secret
        pb_subtype = pb_subtype()


    TYPE_Repeated_r_secret = Repeated_r_secret


    @property
    def r_secret__stream(self):
        if 56 in self._cache:
            def acc(v):
                v_ = lambda: v
                return v_
            return [acc(v) for v in self._cache[56]]
        return self._get_repeated(56, self.TYPE_Repeated_r_secret, "r_secret", lazy=True)

    def r_secret__fast_append(self, value):
        self._append_to_repeated(56, self.TYPE_Repeated_r_secret, value)

    def _get_r_secret(self):
        if 56 in self._cache:
            r = self._cache[56]
        else:
            r = self._buf_get(56, self.TYPE_Repeated_r_secret, 'r_secret')
            self._cache[56] = r
        return r

    def _establish_parentage_r_secret(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_secret), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_secret
                v._pbf_establish_parent_callback = self._establish_parentage_r_secret

    def _set_r_secret(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_secret(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field r_secret"
            raise ProtoValueError(list_assign_error)
        self._cache[56] = v
        self._mods[56] = self.TYPE_Repeated_r_secret

    def _mod_r_secret(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[56] = self.TYPE_Repeated_r_secret

    def _del_r_secret(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 56 in self._cache:
            del self._cache[56]
        if 56 in self._mods:
            del self._mods[56]
        self._buf_del(56)

    _pb_field_name_56 = "r_secret"

    r_secret = property(_get_r_secret, _set_r_secret, _del_r_secret)

    @property
    def r_secret__exists(self):
        return 56 in self._mods or self._buf_exists(56)

    @property
    def r_secret__type(self):
        return self.TYPE_Repeated_r_secret

    def _finalize_r_secret(cls):
        if is_string(cls.TYPE_Repeated_r_secret):
            cls._pbf_strings.append(56)
        elif _PB_type(cls.TYPE_Repeated_r_secret) is _PB_type:
            assert issubclass(cls.TYPE_Repeated_r_secret, RepeatedSequence)
            if is_string(cls.TYPE_Repeated_r_secret.pb_subtype):
                cls._pbf_strings.append(56)

    _pbf_finalizers.append(_finalize_r_secret)


    def _get_chosen_class(self):
        if 57 in self._cache:
            r = self._cache[57]
        else:
            try:
                r = self._buf_get(57, Test.TYPE_AirplaneClass, 'chosen_class')
            except:
                r = Test.ECONOMY
            self._cache[57] = r
        return r

    def _establish_parentage_chosen_class(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_chosen_class), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_chosen_class
                v._pbf_establish_parent_callback = self._establish_parentage_chosen_class

    def _set_chosen_class(self, v, modifying=True):
        self._evermod = modifying or self._evermod
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_chosen_class(v)
        elif isinstance(v, list):
            list_assign_error = "Can't assign list to repeated field chosen_class"
            raise ProtoValueError(list_assign_error)
        self._cache[57] = v
        self._mods[57] = Test.TYPE_AirplaneClass

    def _mod_chosen_class(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[57] = Test.TYPE_AirplaneClass

    def _del_chosen_class(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 57 in self._cache:
            del self._cache[57]
        if 57 in self._mods:
            del self._mods[57]
        self._buf_del(57)

    _pb_field_name_57 = "chosen_class"

    chosen_class = property(_get_chosen_class, _set_chosen_class, _del_chosen_class)

    @property
    def chosen_class__exists(self):
        return 57 in self._mods or self._buf_exists(57)

    @property
    def chosen_class__type(self):
        return Test.TYPE_AirplaneClass

    def _finalize_chosen_class(cls):
        if is_string(Test.TYPE_AirplaneClass):
            cls._pbf_strings.append(57)
        elif _PB_type(Test.TYPE_AirplaneClass) is _PB_type:
            assert issubclass(Test.TYPE_AirplaneClass, RepeatedSequence)
            if is_string(Test.TYPE_AirplaneClass.pb_subtype):
                cls._pbf_strings.append(57)

    _pbf_finalizers.append(_finalize_chosen_class)


TYPE_Test = Test
_PB_finalizers.append('Test')


for cname in _PB_finalizers:
    eval(cname)._pbf_finalize()

del _PB_finalizers
