from palm import ProtoBase, RepeatedSequence, ProtoEnumeration

from foo_palm import *

class Test(ProtoBase):
    def __init__(self, _pbf_buf='', _pbf_parent_callback=None): # XXX support setting
        ProtoBase.__init__(self, _pbf_buf)
        self._cache = {}
        self._mods = {}
        self._pbf_parent_callback = _pbf_parent_callback
        self._pbf_establish_parent_callback = None

    def fields(self):
        return ['sha1', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'k', 'l', 'm', 'n', 'o', 'msg', 'yn', 'cls', 'p', 'q', 'r', 'r_sha1', 'r_a', 'r_b', 'r_c', 'r_d', 'r_e', 'r_f', 'r_g', 'r_h', 'r_i', 'r_k', 'r_l', 'r_m', 'r_n', 'r_o', 'r_msg', 'r_yn', 'r_cls']

    def __str__(self):
        return '\n'.join('%s: %s' % (f, repr(getattr(self, '_get_%s' % f)())) for f in self.fields()
                          if getattr(self, '%s__exists' % f))
    
    class AirplaneClass(ProtoEnumeration):
        FIRST = 0
        ECONOMY = 1
        BUSINESS = 2
        
    
    TYPE_AirplaneClass = ProtoBase.TYPE_int32
        
    class Foo(ProtoBase):
        def __init__(self, _pbf_buf='', _pbf_parent_callback=None): # XXX support setting
            ProtoBase.__init__(self, _pbf_buf)
            self._cache = {}
            self._mods = {}
            self._pbf_parent_callback = _pbf_parent_callback
            self._pbf_establish_parent_callback = None
    
        def fields(self):
            return ['baz']
    
        def __str__(self):
            return '\n'.join('%s: %s' % (f, repr(getattr(self, '_get_%s' % f)())) for f in self.fields()
                              if getattr(self, '%s__exists' % f))
        
        def _get_baz(self):
            if 8 in self._cache:
                r = self._cache[8]
            else:
                r = self._buf_get(8, self.TYPE_string, 'baz')
                self._cache[8] = r
            return r
    
        def _establish_parentage_baz(self, v):
            if isinstance(v, (ProtoBase, RepeatedSequence)):
                if v._pbf_parent_callback:
                    assert (v._pbf_parent_callback == self._mod_baz), "subobjects can only have one parent--use copy()?"
                else:
                    v._pbf_parent_callback = self._mod_baz
                    v._pbf_establish_parent_callback = self._establish_parentage_baz
    
        def _set_baz(self, v):
            self._evermod = True
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            if isinstance(v, (ProtoBase, RepeatedSequence)):
                self._establish_parentage_baz(v)
            self._cache[8] = v
            self._mods[8] = self.TYPE_string
    
        def _mod_baz(self):
            self._evermod = True
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            self._mods[8] = self.TYPE_string
    
        def _del_baz(self):
            self._evermod = True
            if self._pbf_parent_callback:
                self._pbf_parent_callback()
            if 8 in self._cache:
                del self._cache[8]
            if 8 in self._mods:
                del self._mods[8]
            self._buf_del(8)
    
        _pb_field_name_8 = "baz"
    
        baz = property(_get_baz, _set_baz, _del_baz)
    
        @property
        def baz__exists(self):
            return 8 in self._mods or self._buf_exists(8)
    
    
    TYPE_Foo = Foo

    def _get_sha1(self):
        if 1 in self._cache:
            r = self._cache[1]
        else:
            r = self._buf_get(1, self.TYPE_string, 'sha1')
            self._cache[1] = r
        return r

    def _establish_parentage_sha1(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_sha1), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_sha1
                v._pbf_establish_parent_callback = self._establish_parentage_sha1

    def _set_sha1(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_sha1(v)
        self._cache[1] = v
        self._mods[1] = self.TYPE_string

    def _mod_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[1] = self.TYPE_string

    def _del_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 1 in self._cache:
            del self._cache[1]
        if 1 in self._mods:
            del self._mods[1]
        self._buf_del(1)

    _pb_field_name_1 = "sha1"

    sha1 = property(_get_sha1, _set_sha1, _del_sha1)

    @property
    def sha1__exists(self):
        return 1 in self._mods or self._buf_exists(1)


    def _get_a(self):
        if 2 in self._cache:
            r = self._cache[2]
        else:
            r = self._buf_get(2, self.TYPE_uint32, 'a')
            self._cache[2] = r
        return r

    def _establish_parentage_a(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_a), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_a
                v._pbf_establish_parent_callback = self._establish_parentage_a

    def _set_a(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_a(v)
        self._cache[2] = v
        self._mods[2] = self.TYPE_uint32

    def _mod_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[2] = self.TYPE_uint32

    def _del_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 2 in self._cache:
            del self._cache[2]
        if 2 in self._mods:
            del self._mods[2]
        self._buf_del(2)

    _pb_field_name_2 = "a"

    a = property(_get_a, _set_a, _del_a)

    @property
    def a__exists(self):
        return 2 in self._mods or self._buf_exists(2)


    def _get_b(self):
        if 3 in self._cache:
            r = self._cache[3]
        else:
            r = self._buf_get(3, self.TYPE_int32, 'b')
            self._cache[3] = r
        return r

    def _establish_parentage_b(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_b), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_b
                v._pbf_establish_parent_callback = self._establish_parentage_b

    def _set_b(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_b(v)
        self._cache[3] = v
        self._mods[3] = self.TYPE_int32

    def _mod_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[3] = self.TYPE_int32

    def _del_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 3 in self._cache:
            del self._cache[3]
        if 3 in self._mods:
            del self._mods[3]
        self._buf_del(3)

    _pb_field_name_3 = "b"

    b = property(_get_b, _set_b, _del_b)

    @property
    def b__exists(self):
        return 3 in self._mods or self._buf_exists(3)


    def _get_c(self):
        if 4 in self._cache:
            r = self._cache[4]
        else:
            r = self._buf_get(4, self.TYPE_sint32, 'c')
            self._cache[4] = r
        return r

    def _establish_parentage_c(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_c), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_c
                v._pbf_establish_parent_callback = self._establish_parentage_c

    def _set_c(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_c(v)
        self._cache[4] = v
        self._mods[4] = self.TYPE_sint32

    def _mod_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[4] = self.TYPE_sint32

    def _del_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 4 in self._cache:
            del self._cache[4]
        if 4 in self._mods:
            del self._mods[4]
        self._buf_del(4)

    _pb_field_name_4 = "c"

    c = property(_get_c, _set_c, _del_c)

    @property
    def c__exists(self):
        return 4 in self._mods or self._buf_exists(4)


    def _get_d(self):
        if 5 in self._cache:
            r = self._cache[5]
        else:
            r = self._buf_get(5, self.TYPE_uint64, 'd')
            self._cache[5] = r
        return r

    def _establish_parentage_d(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_d), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_d
                v._pbf_establish_parent_callback = self._establish_parentage_d

    def _set_d(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_d(v)
        self._cache[5] = v
        self._mods[5] = self.TYPE_uint64

    def _mod_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[5] = self.TYPE_uint64

    def _del_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 5 in self._cache:
            del self._cache[5]
        if 5 in self._mods:
            del self._mods[5]
        self._buf_del(5)

    _pb_field_name_5 = "d"

    d = property(_get_d, _set_d, _del_d)

    @property
    def d__exists(self):
        return 5 in self._mods or self._buf_exists(5)


    def _get_e(self):
        if 6 in self._cache:
            r = self._cache[6]
        else:
            r = self._buf_get(6, self.TYPE_int64, 'e')
            self._cache[6] = r
        return r

    def _establish_parentage_e(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_e), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_e
                v._pbf_establish_parent_callback = self._establish_parentage_e

    def _set_e(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_e(v)
        self._cache[6] = v
        self._mods[6] = self.TYPE_int64

    def _mod_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[6] = self.TYPE_int64

    def _del_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 6 in self._cache:
            del self._cache[6]
        if 6 in self._mods:
            del self._mods[6]
        self._buf_del(6)

    _pb_field_name_6 = "e"

    e = property(_get_e, _set_e, _del_e)

    @property
    def e__exists(self):
        return 6 in self._mods or self._buf_exists(6)


    def _get_f(self):
        if 7 in self._cache:
            r = self._cache[7]
        else:
            r = self._buf_get(7, self.TYPE_sint64, 'f')
            self._cache[7] = r
        return r

    def _establish_parentage_f(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_f), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_f
                v._pbf_establish_parent_callback = self._establish_parentage_f

    def _set_f(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_f(v)
        self._cache[7] = v
        self._mods[7] = self.TYPE_sint64

    def _mod_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[7] = self.TYPE_sint64

    def _del_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 7 in self._cache:
            del self._cache[7]
        if 7 in self._mods:
            del self._mods[7]
        self._buf_del(7)

    _pb_field_name_7 = "f"

    f = property(_get_f, _set_f, _del_f)

    @property
    def f__exists(self):
        return 7 in self._mods or self._buf_exists(7)


    def _get_g(self):
        if 9 in self._cache:
            r = self._cache[9]
        else:
            r = self._buf_get(9, self.TYPE_fixed64, 'g')
            self._cache[9] = r
        return r

    def _establish_parentage_g(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_g), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_g
                v._pbf_establish_parent_callback = self._establish_parentage_g

    def _set_g(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_g(v)
        self._cache[9] = v
        self._mods[9] = self.TYPE_fixed64

    def _mod_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[9] = self.TYPE_fixed64

    def _del_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 9 in self._cache:
            del self._cache[9]
        if 9 in self._mods:
            del self._mods[9]
        self._buf_del(9)

    _pb_field_name_9 = "g"

    g = property(_get_g, _set_g, _del_g)

    @property
    def g__exists(self):
        return 9 in self._mods or self._buf_exists(9)


    def _get_h(self):
        if 10 in self._cache:
            r = self._cache[10]
        else:
            r = self._buf_get(10, self.TYPE_sfixed64, 'h')
            self._cache[10] = r
        return r

    def _establish_parentage_h(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_h), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_h
                v._pbf_establish_parent_callback = self._establish_parentage_h

    def _set_h(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_h(v)
        self._cache[10] = v
        self._mods[10] = self.TYPE_sfixed64

    def _mod_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[10] = self.TYPE_sfixed64

    def _del_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 10 in self._cache:
            del self._cache[10]
        if 10 in self._mods:
            del self._mods[10]
        self._buf_del(10)

    _pb_field_name_10 = "h"

    h = property(_get_h, _set_h, _del_h)

    @property
    def h__exists(self):
        return 10 in self._mods or self._buf_exists(10)


    def _get_i(self):
        if 11 in self._cache:
            r = self._cache[11]
        else:
            r = self._buf_get(11, self.TYPE_sfixed64, 'i')
            self._cache[11] = r
        return r

    def _establish_parentage_i(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_i), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_i
                v._pbf_establish_parent_callback = self._establish_parentage_i

    def _set_i(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_i(v)
        self._cache[11] = v
        self._mods[11] = self.TYPE_sfixed64

    def _mod_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[11] = self.TYPE_sfixed64

    def _del_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 11 in self._cache:
            del self._cache[11]
        if 11 in self._mods:
            del self._mods[11]
        self._buf_del(11)

    _pb_field_name_11 = "i"

    i = property(_get_i, _set_i, _del_i)

    @property
    def i__exists(self):
        return 11 in self._mods or self._buf_exists(11)


    def _get_k(self):
        if 12 in self._cache:
            r = self._cache[12]
        else:
            r = self._buf_get(12, self.TYPE_double, 'k')
            self._cache[12] = r
        return r

    def _establish_parentage_k(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_k), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_k
                v._pbf_establish_parent_callback = self._establish_parentage_k

    def _set_k(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_k(v)
        self._cache[12] = v
        self._mods[12] = self.TYPE_double

    def _mod_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[12] = self.TYPE_double

    def _del_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 12 in self._cache:
            del self._cache[12]
        if 12 in self._mods:
            del self._mods[12]
        self._buf_del(12)

    _pb_field_name_12 = "k"

    k = property(_get_k, _set_k, _del_k)

    @property
    def k__exists(self):
        return 12 in self._mods or self._buf_exists(12)


    def _get_l(self):
        if 13 in self._cache:
            r = self._cache[13]
        else:
            r = self._buf_get(13, self.TYPE_fixed32, 'l')
            self._cache[13] = r
        return r

    def _establish_parentage_l(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_l), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_l
                v._pbf_establish_parent_callback = self._establish_parentage_l

    def _set_l(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_l(v)
        self._cache[13] = v
        self._mods[13] = self.TYPE_fixed32

    def _mod_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[13] = self.TYPE_fixed32

    def _del_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 13 in self._cache:
            del self._cache[13]
        if 13 in self._mods:
            del self._mods[13]
        self._buf_del(13)

    _pb_field_name_13 = "l"

    l = property(_get_l, _set_l, _del_l)

    @property
    def l__exists(self):
        return 13 in self._mods or self._buf_exists(13)


    def _get_m(self):
        if 14 in self._cache:
            r = self._cache[14]
        else:
            r = self._buf_get(14, self.TYPE_sfixed32, 'm')
            self._cache[14] = r
        return r

    def _establish_parentage_m(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_m), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_m
                v._pbf_establish_parent_callback = self._establish_parentage_m

    def _set_m(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_m(v)
        self._cache[14] = v
        self._mods[14] = self.TYPE_sfixed32

    def _mod_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[14] = self.TYPE_sfixed32

    def _del_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 14 in self._cache:
            del self._cache[14]
        if 14 in self._mods:
            del self._mods[14]
        self._buf_del(14)

    _pb_field_name_14 = "m"

    m = property(_get_m, _set_m, _del_m)

    @property
    def m__exists(self):
        return 14 in self._mods or self._buf_exists(14)


    def _get_n(self):
        if 15 in self._cache:
            r = self._cache[15]
        else:
            r = self._buf_get(15, self.TYPE_sfixed32, 'n')
            self._cache[15] = r
        return r

    def _establish_parentage_n(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_n), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_n
                v._pbf_establish_parent_callback = self._establish_parentage_n

    def _set_n(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_n(v)
        self._cache[15] = v
        self._mods[15] = self.TYPE_sfixed32

    def _mod_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[15] = self.TYPE_sfixed32

    def _del_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 15 in self._cache:
            del self._cache[15]
        if 15 in self._mods:
            del self._mods[15]
        self._buf_del(15)

    _pb_field_name_15 = "n"

    n = property(_get_n, _set_n, _del_n)

    @property
    def n__exists(self):
        return 15 in self._mods or self._buf_exists(15)


    def _get_o(self):
        if 16 in self._cache:
            r = self._cache[16]
        else:
            r = self._buf_get(16, self.TYPE_float, 'o')
            self._cache[16] = r
        return r

    def _establish_parentage_o(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_o), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_o
                v._pbf_establish_parent_callback = self._establish_parentage_o

    def _set_o(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_o(v)
        self._cache[16] = v
        self._mods[16] = self.TYPE_float

    def _mod_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[16] = self.TYPE_float

    def _del_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 16 in self._cache:
            del self._cache[16]
        if 16 in self._mods:
            del self._mods[16]
        self._buf_del(16)

    _pb_field_name_16 = "o"

    o = property(_get_o, _set_o, _del_o)

    @property
    def o__exists(self):
        return 16 in self._mods or self._buf_exists(16)


    def _get_msg(self):
        if 17 in self._cache:
            r = self._cache[17]
        else:
            r = self._buf_get(17, self.TYPE_Foo, 'msg')
            self._cache[17] = r
        return r

    def _establish_parentage_msg(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_msg), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_msg
                v._pbf_establish_parent_callback = self._establish_parentage_msg

    def _set_msg(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_msg(v)
        self._cache[17] = v
        self._mods[17] = self.TYPE_Foo

    def _mod_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[17] = self.TYPE_Foo

    def _del_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 17 in self._cache:
            del self._cache[17]
        if 17 in self._mods:
            del self._mods[17]
        self._buf_del(17)

    _pb_field_name_17 = "msg"

    msg = property(_get_msg, _set_msg, _del_msg)

    @property
    def msg__exists(self):
        return 17 in self._mods or self._buf_exists(17)


    def _get_yn(self):
        if 18 in self._cache:
            r = self._cache[18]
        else:
            r = self._buf_get(18, self.TYPE_bool, 'yn')
            self._cache[18] = r
        return r

    def _establish_parentage_yn(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_yn), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_yn
                v._pbf_establish_parent_callback = self._establish_parentage_yn

    def _set_yn(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_yn(v)
        self._cache[18] = v
        self._mods[18] = self.TYPE_bool

    def _mod_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[18] = self.TYPE_bool

    def _del_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 18 in self._cache:
            del self._cache[18]
        if 18 in self._mods:
            del self._mods[18]
        self._buf_del(18)

    _pb_field_name_18 = "yn"

    yn = property(_get_yn, _set_yn, _del_yn)

    @property
    def yn__exists(self):
        return 18 in self._mods or self._buf_exists(18)


    def _get_cls(self):
        if 19 in self._cache:
            r = self._cache[19]
        else:
            r = self._buf_get(19, self.TYPE_AirplaneClass, 'cls')
            self._cache[19] = r
        return r

    def _establish_parentage_cls(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_cls), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_cls
                v._pbf_establish_parent_callback = self._establish_parentage_cls

    def _set_cls(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_cls(v)
        self._cache[19] = v
        self._mods[19] = self.TYPE_AirplaneClass

    def _mod_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[19] = self.TYPE_AirplaneClass

    def _del_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 19 in self._cache:
            del self._cache[19]
        if 19 in self._mods:
            del self._mods[19]
        self._buf_del(19)

    _pb_field_name_19 = "cls"

    cls = property(_get_cls, _set_cls, _del_cls)

    @property
    def cls__exists(self):
        return 19 in self._mods or self._buf_exists(19)


    def _get_p(self):
        if 21 in self._cache:
            r = self._cache[21]
        else:
            try:
                r = self._buf_get(21, self.TYPE_uint32, 'p')
            except:
                r = 13
            self._cache[21] = r
        return r

    def _establish_parentage_p(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_p), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_p
                v._pbf_establish_parent_callback = self._establish_parentage_p

    def _set_p(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_p(v)
        self._cache[21] = v
        self._mods[21] = self.TYPE_uint32

    def _mod_p(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[21] = self.TYPE_uint32

    def _del_p(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 21 in self._cache:
            del self._cache[21]
        if 21 in self._mods:
            del self._mods[21]
        self._buf_del(21)

    _pb_field_name_21 = "p"

    p = property(_get_p, _set_p, _del_p)

    @property
    def p__exists(self):
        return 21 in self._mods or self._buf_exists(21)


    def _get_q(self):
        if 22 in self._cache:
            r = self._cache[22]
        else:
            try:
                r = self._buf_get(22, self.TYPE_float, 'q')
            except:
                r = 23.4
            self._cache[22] = r
        return r

    def _establish_parentage_q(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_q), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_q
                v._pbf_establish_parent_callback = self._establish_parentage_q

    def _set_q(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_q(v)
        self._cache[22] = v
        self._mods[22] = self.TYPE_float

    def _mod_q(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[22] = self.TYPE_float

    def _del_q(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 22 in self._cache:
            del self._cache[22]
        if 22 in self._mods:
            del self._mods[22]
        self._buf_del(22)

    _pb_field_name_22 = "q"

    q = property(_get_q, _set_q, _del_q)

    @property
    def q__exists(self):
        return 22 in self._mods or self._buf_exists(22)


    def _get_r(self):
        if 23 in self._cache:
            r = self._cache[23]
        else:
            try:
                r = self._buf_get(23, self.TYPE_string, 'r')
            except:
                r = "cats"
            self._cache[23] = r
        return r

    def _establish_parentage_r(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r
                v._pbf_establish_parent_callback = self._establish_parentage_r

    def _set_r(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r(v)
        self._cache[23] = v
        self._mods[23] = self.TYPE_string

    def _mod_r(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[23] = self.TYPE_string

    def _del_r(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 23 in self._cache:
            del self._cache[23]
        if 23 in self._mods:
            del self._mods[23]
        self._buf_del(23)

    _pb_field_name_23 = "r"

    r = property(_get_r, _set_r, _del_r)

    @property
    def r__exists(self):
        return 23 in self._mods or self._buf_exists(23)


    class Repeated_r_sha1(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_sha1.pb_subtype = ProtoBase.TYPE_string

    TYPE_Repeated_r_sha1 = Repeated_r_sha1

    def _get_r_sha1(self):
        if 31 in self._cache:
            r = self._cache[31]
        else:
            r = self._buf_get(31, self.TYPE_Repeated_r_sha1, 'r_sha1')
            self._cache[31] = r
        return r

    def _establish_parentage_r_sha1(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_sha1), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_sha1
                v._pbf_establish_parent_callback = self._establish_parentage_r_sha1

    def _set_r_sha1(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_sha1(v)
        self._cache[31] = v
        self._mods[31] = self.TYPE_Repeated_r_sha1

    def _mod_r_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[31] = self.TYPE_Repeated_r_sha1

    def _del_r_sha1(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 31 in self._cache:
            del self._cache[31]
        if 31 in self._mods:
            del self._mods[31]
        self._buf_del(31)

    _pb_field_name_31 = "r_sha1"

    r_sha1 = property(_get_r_sha1, _set_r_sha1, _del_r_sha1)

    @property
    def r_sha1__exists(self):
        return 31 in self._mods or self._buf_exists(31)


    class Repeated_r_a(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_a.pb_subtype = ProtoBase.TYPE_uint32

    TYPE_Repeated_r_a = Repeated_r_a

    def _get_r_a(self):
        if 32 in self._cache:
            r = self._cache[32]
        else:
            r = self._buf_get(32, self.TYPE_Repeated_r_a, 'r_a')
            self._cache[32] = r
        return r

    def _establish_parentage_r_a(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_a), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_a
                v._pbf_establish_parent_callback = self._establish_parentage_r_a

    def _set_r_a(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_a(v)
        self._cache[32] = v
        self._mods[32] = self.TYPE_Repeated_r_a

    def _mod_r_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[32] = self.TYPE_Repeated_r_a

    def _del_r_a(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 32 in self._cache:
            del self._cache[32]
        if 32 in self._mods:
            del self._mods[32]
        self._buf_del(32)

    _pb_field_name_32 = "r_a"

    r_a = property(_get_r_a, _set_r_a, _del_r_a)

    @property
    def r_a__exists(self):
        return 32 in self._mods or self._buf_exists(32)


    class Repeated_r_b(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_b.pb_subtype = ProtoBase.TYPE_int32

    TYPE_Repeated_r_b = Repeated_r_b

    def _get_r_b(self):
        if 33 in self._cache:
            r = self._cache[33]
        else:
            r = self._buf_get(33, self.TYPE_Repeated_r_b, 'r_b')
            self._cache[33] = r
        return r

    def _establish_parentage_r_b(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_b), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_b
                v._pbf_establish_parent_callback = self._establish_parentage_r_b

    def _set_r_b(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_b(v)
        self._cache[33] = v
        self._mods[33] = self.TYPE_Repeated_r_b

    def _mod_r_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[33] = self.TYPE_Repeated_r_b

    def _del_r_b(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 33 in self._cache:
            del self._cache[33]
        if 33 in self._mods:
            del self._mods[33]
        self._buf_del(33)

    _pb_field_name_33 = "r_b"

    r_b = property(_get_r_b, _set_r_b, _del_r_b)

    @property
    def r_b__exists(self):
        return 33 in self._mods or self._buf_exists(33)


    class Repeated_r_c(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_c.pb_subtype = ProtoBase.TYPE_sint32

    TYPE_Repeated_r_c = Repeated_r_c

    def _get_r_c(self):
        if 34 in self._cache:
            r = self._cache[34]
        else:
            r = self._buf_get(34, self.TYPE_Repeated_r_c, 'r_c')
            self._cache[34] = r
        return r

    def _establish_parentage_r_c(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_c), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_c
                v._pbf_establish_parent_callback = self._establish_parentage_r_c

    def _set_r_c(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_c(v)
        self._cache[34] = v
        self._mods[34] = self.TYPE_Repeated_r_c

    def _mod_r_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[34] = self.TYPE_Repeated_r_c

    def _del_r_c(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 34 in self._cache:
            del self._cache[34]
        if 34 in self._mods:
            del self._mods[34]
        self._buf_del(34)

    _pb_field_name_34 = "r_c"

    r_c = property(_get_r_c, _set_r_c, _del_r_c)

    @property
    def r_c__exists(self):
        return 34 in self._mods or self._buf_exists(34)


    class Repeated_r_d(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_d.pb_subtype = ProtoBase.TYPE_uint64

    TYPE_Repeated_r_d = Repeated_r_d

    def _get_r_d(self):
        if 35 in self._cache:
            r = self._cache[35]
        else:
            r = self._buf_get(35, self.TYPE_Repeated_r_d, 'r_d')
            self._cache[35] = r
        return r

    def _establish_parentage_r_d(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_d), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_d
                v._pbf_establish_parent_callback = self._establish_parentage_r_d

    def _set_r_d(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_d(v)
        self._cache[35] = v
        self._mods[35] = self.TYPE_Repeated_r_d

    def _mod_r_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[35] = self.TYPE_Repeated_r_d

    def _del_r_d(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 35 in self._cache:
            del self._cache[35]
        if 35 in self._mods:
            del self._mods[35]
        self._buf_del(35)

    _pb_field_name_35 = "r_d"

    r_d = property(_get_r_d, _set_r_d, _del_r_d)

    @property
    def r_d__exists(self):
        return 35 in self._mods or self._buf_exists(35)


    class Repeated_r_e(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_e.pb_subtype = ProtoBase.TYPE_int64

    TYPE_Repeated_r_e = Repeated_r_e

    def _get_r_e(self):
        if 36 in self._cache:
            r = self._cache[36]
        else:
            r = self._buf_get(36, self.TYPE_Repeated_r_e, 'r_e')
            self._cache[36] = r
        return r

    def _establish_parentage_r_e(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_e), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_e
                v._pbf_establish_parent_callback = self._establish_parentage_r_e

    def _set_r_e(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_e(v)
        self._cache[36] = v
        self._mods[36] = self.TYPE_Repeated_r_e

    def _mod_r_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[36] = self.TYPE_Repeated_r_e

    def _del_r_e(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 36 in self._cache:
            del self._cache[36]
        if 36 in self._mods:
            del self._mods[36]
        self._buf_del(36)

    _pb_field_name_36 = "r_e"

    r_e = property(_get_r_e, _set_r_e, _del_r_e)

    @property
    def r_e__exists(self):
        return 36 in self._mods or self._buf_exists(36)


    class Repeated_r_f(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_f.pb_subtype = ProtoBase.TYPE_sint64

    TYPE_Repeated_r_f = Repeated_r_f

    def _get_r_f(self):
        if 37 in self._cache:
            r = self._cache[37]
        else:
            r = self._buf_get(37, self.TYPE_Repeated_r_f, 'r_f')
            self._cache[37] = r
        return r

    def _establish_parentage_r_f(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_f), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_f
                v._pbf_establish_parent_callback = self._establish_parentage_r_f

    def _set_r_f(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_f(v)
        self._cache[37] = v
        self._mods[37] = self.TYPE_Repeated_r_f

    def _mod_r_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[37] = self.TYPE_Repeated_r_f

    def _del_r_f(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 37 in self._cache:
            del self._cache[37]
        if 37 in self._mods:
            del self._mods[37]
        self._buf_del(37)

    _pb_field_name_37 = "r_f"

    r_f = property(_get_r_f, _set_r_f, _del_r_f)

    @property
    def r_f__exists(self):
        return 37 in self._mods or self._buf_exists(37)


    class Repeated_r_g(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_g.pb_subtype = ProtoBase.TYPE_fixed64

    TYPE_Repeated_r_g = Repeated_r_g

    def _get_r_g(self):
        if 39 in self._cache:
            r = self._cache[39]
        else:
            r = self._buf_get(39, self.TYPE_Repeated_r_g, 'r_g')
            self._cache[39] = r
        return r

    def _establish_parentage_r_g(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_g), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_g
                v._pbf_establish_parent_callback = self._establish_parentage_r_g

    def _set_r_g(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_g(v)
        self._cache[39] = v
        self._mods[39] = self.TYPE_Repeated_r_g

    def _mod_r_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[39] = self.TYPE_Repeated_r_g

    def _del_r_g(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 39 in self._cache:
            del self._cache[39]
        if 39 in self._mods:
            del self._mods[39]
        self._buf_del(39)

    _pb_field_name_39 = "r_g"

    r_g = property(_get_r_g, _set_r_g, _del_r_g)

    @property
    def r_g__exists(self):
        return 39 in self._mods or self._buf_exists(39)


    class Repeated_r_h(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_h.pb_subtype = ProtoBase.TYPE_sfixed64

    TYPE_Repeated_r_h = Repeated_r_h

    def _get_r_h(self):
        if 40 in self._cache:
            r = self._cache[40]
        else:
            r = self._buf_get(40, self.TYPE_Repeated_r_h, 'r_h')
            self._cache[40] = r
        return r

    def _establish_parentage_r_h(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_h), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_h
                v._pbf_establish_parent_callback = self._establish_parentage_r_h

    def _set_r_h(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_h(v)
        self._cache[40] = v
        self._mods[40] = self.TYPE_Repeated_r_h

    def _mod_r_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[40] = self.TYPE_Repeated_r_h

    def _del_r_h(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 40 in self._cache:
            del self._cache[40]
        if 40 in self._mods:
            del self._mods[40]
        self._buf_del(40)

    _pb_field_name_40 = "r_h"

    r_h = property(_get_r_h, _set_r_h, _del_r_h)

    @property
    def r_h__exists(self):
        return 40 in self._mods or self._buf_exists(40)


    class Repeated_r_i(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_i.pb_subtype = ProtoBase.TYPE_sfixed64

    TYPE_Repeated_r_i = Repeated_r_i

    def _get_r_i(self):
        if 41 in self._cache:
            r = self._cache[41]
        else:
            r = self._buf_get(41, self.TYPE_Repeated_r_i, 'r_i')
            self._cache[41] = r
        return r

    def _establish_parentage_r_i(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_i), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_i
                v._pbf_establish_parent_callback = self._establish_parentage_r_i

    def _set_r_i(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_i(v)
        self._cache[41] = v
        self._mods[41] = self.TYPE_Repeated_r_i

    def _mod_r_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[41] = self.TYPE_Repeated_r_i

    def _del_r_i(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 41 in self._cache:
            del self._cache[41]
        if 41 in self._mods:
            del self._mods[41]
        self._buf_del(41)

    _pb_field_name_41 = "r_i"

    r_i = property(_get_r_i, _set_r_i, _del_r_i)

    @property
    def r_i__exists(self):
        return 41 in self._mods or self._buf_exists(41)


    class Repeated_r_k(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_k.pb_subtype = ProtoBase.TYPE_double

    TYPE_Repeated_r_k = Repeated_r_k

    def _get_r_k(self):
        if 42 in self._cache:
            r = self._cache[42]
        else:
            r = self._buf_get(42, self.TYPE_Repeated_r_k, 'r_k')
            self._cache[42] = r
        return r

    def _establish_parentage_r_k(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_k), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_k
                v._pbf_establish_parent_callback = self._establish_parentage_r_k

    def _set_r_k(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_k(v)
        self._cache[42] = v
        self._mods[42] = self.TYPE_Repeated_r_k

    def _mod_r_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[42] = self.TYPE_Repeated_r_k

    def _del_r_k(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 42 in self._cache:
            del self._cache[42]
        if 42 in self._mods:
            del self._mods[42]
        self._buf_del(42)

    _pb_field_name_42 = "r_k"

    r_k = property(_get_r_k, _set_r_k, _del_r_k)

    @property
    def r_k__exists(self):
        return 42 in self._mods or self._buf_exists(42)


    class Repeated_r_l(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_l.pb_subtype = ProtoBase.TYPE_fixed32

    TYPE_Repeated_r_l = Repeated_r_l

    def _get_r_l(self):
        if 43 in self._cache:
            r = self._cache[43]
        else:
            r = self._buf_get(43, self.TYPE_Repeated_r_l, 'r_l')
            self._cache[43] = r
        return r

    def _establish_parentage_r_l(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_l), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_l
                v._pbf_establish_parent_callback = self._establish_parentage_r_l

    def _set_r_l(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_l(v)
        self._cache[43] = v
        self._mods[43] = self.TYPE_Repeated_r_l

    def _mod_r_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[43] = self.TYPE_Repeated_r_l

    def _del_r_l(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 43 in self._cache:
            del self._cache[43]
        if 43 in self._mods:
            del self._mods[43]
        self._buf_del(43)

    _pb_field_name_43 = "r_l"

    r_l = property(_get_r_l, _set_r_l, _del_r_l)

    @property
    def r_l__exists(self):
        return 43 in self._mods or self._buf_exists(43)


    class Repeated_r_m(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_m.pb_subtype = ProtoBase.TYPE_sfixed32

    TYPE_Repeated_r_m = Repeated_r_m

    def _get_r_m(self):
        if 44 in self._cache:
            r = self._cache[44]
        else:
            r = self._buf_get(44, self.TYPE_Repeated_r_m, 'r_m')
            self._cache[44] = r
        return r

    def _establish_parentage_r_m(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_m), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_m
                v._pbf_establish_parent_callback = self._establish_parentage_r_m

    def _set_r_m(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_m(v)
        self._cache[44] = v
        self._mods[44] = self.TYPE_Repeated_r_m

    def _mod_r_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[44] = self.TYPE_Repeated_r_m

    def _del_r_m(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 44 in self._cache:
            del self._cache[44]
        if 44 in self._mods:
            del self._mods[44]
        self._buf_del(44)

    _pb_field_name_44 = "r_m"

    r_m = property(_get_r_m, _set_r_m, _del_r_m)

    @property
    def r_m__exists(self):
        return 44 in self._mods or self._buf_exists(44)


    class Repeated_r_n(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_n.pb_subtype = ProtoBase.TYPE_sfixed32

    TYPE_Repeated_r_n = Repeated_r_n

    def _get_r_n(self):
        if 45 in self._cache:
            r = self._cache[45]
        else:
            r = self._buf_get(45, self.TYPE_Repeated_r_n, 'r_n')
            self._cache[45] = r
        return r

    def _establish_parentage_r_n(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_n), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_n
                v._pbf_establish_parent_callback = self._establish_parentage_r_n

    def _set_r_n(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_n(v)
        self._cache[45] = v
        self._mods[45] = self.TYPE_Repeated_r_n

    def _mod_r_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[45] = self.TYPE_Repeated_r_n

    def _del_r_n(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 45 in self._cache:
            del self._cache[45]
        if 45 in self._mods:
            del self._mods[45]
        self._buf_del(45)

    _pb_field_name_45 = "r_n"

    r_n = property(_get_r_n, _set_r_n, _del_r_n)

    @property
    def r_n__exists(self):
        return 45 in self._mods or self._buf_exists(45)


    class Repeated_r_o(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_o.pb_subtype = ProtoBase.TYPE_float

    TYPE_Repeated_r_o = Repeated_r_o

    def _get_r_o(self):
        if 46 in self._cache:
            r = self._cache[46]
        else:
            r = self._buf_get(46, self.TYPE_Repeated_r_o, 'r_o')
            self._cache[46] = r
        return r

    def _establish_parentage_r_o(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_o), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_o
                v._pbf_establish_parent_callback = self._establish_parentage_r_o

    def _set_r_o(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_o(v)
        self._cache[46] = v
        self._mods[46] = self.TYPE_Repeated_r_o

    def _mod_r_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[46] = self.TYPE_Repeated_r_o

    def _del_r_o(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 46 in self._cache:
            del self._cache[46]
        if 46 in self._mods:
            del self._mods[46]
        self._buf_del(46)

    _pb_field_name_46 = "r_o"

    r_o = property(_get_r_o, _set_r_o, _del_r_o)

    @property
    def r_o__exists(self):
        return 46 in self._mods or self._buf_exists(46)


    class Repeated_r_msg(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_msg.pb_subtype = TYPE_Foo

    TYPE_Repeated_r_msg = Repeated_r_msg

    def _get_r_msg(self):
        if 47 in self._cache:
            r = self._cache[47]
        else:
            r = self._buf_get(47, self.TYPE_Repeated_r_msg, 'r_msg')
            self._cache[47] = r
        return r

    def _establish_parentage_r_msg(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_msg), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_msg
                v._pbf_establish_parent_callback = self._establish_parentage_r_msg

    def _set_r_msg(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_msg(v)
        self._cache[47] = v
        self._mods[47] = self.TYPE_Repeated_r_msg

    def _mod_r_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[47] = self.TYPE_Repeated_r_msg

    def _del_r_msg(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 47 in self._cache:
            del self._cache[47]
        if 47 in self._mods:
            del self._mods[47]
        self._buf_del(47)

    _pb_field_name_47 = "r_msg"

    r_msg = property(_get_r_msg, _set_r_msg, _del_r_msg)

    @property
    def r_msg__exists(self):
        return 47 in self._mods or self._buf_exists(47)


    class Repeated_r_yn(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_yn.pb_subtype = ProtoBase.TYPE_bool

    TYPE_Repeated_r_yn = Repeated_r_yn

    def _get_r_yn(self):
        if 48 in self._cache:
            r = self._cache[48]
        else:
            r = self._buf_get(48, self.TYPE_Repeated_r_yn, 'r_yn')
            self._cache[48] = r
        return r

    def _establish_parentage_r_yn(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_yn), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_yn
                v._pbf_establish_parent_callback = self._establish_parentage_r_yn

    def _set_r_yn(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_yn(v)
        self._cache[48] = v
        self._mods[48] = self.TYPE_Repeated_r_yn

    def _mod_r_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[48] = self.TYPE_Repeated_r_yn

    def _del_r_yn(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 48 in self._cache:
            del self._cache[48]
        if 48 in self._mods:
            del self._mods[48]
        self._buf_del(48)

    _pb_field_name_48 = "r_yn"

    r_yn = property(_get_r_yn, _set_r_yn, _del_r_yn)

    @property
    def r_yn__exists(self):
        return 48 in self._mods or self._buf_exists(48)


    class Repeated_r_cls(RepeatedSequence): 
        pb_subtype = None 
    Repeated_r_cls.pb_subtype = TYPE_AirplaneClass

    TYPE_Repeated_r_cls = Repeated_r_cls

    def _get_r_cls(self):
        if 49 in self._cache:
            r = self._cache[49]
        else:
            r = self._buf_get(49, self.TYPE_Repeated_r_cls, 'r_cls')
            self._cache[49] = r
        return r

    def _establish_parentage_r_cls(self, v):
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            if v._pbf_parent_callback:
                assert (v._pbf_parent_callback == self._mod_r_cls), "subobjects can only have one parent--use copy()?"
            else:
                v._pbf_parent_callback = self._mod_r_cls
                v._pbf_establish_parent_callback = self._establish_parentage_r_cls

    def _set_r_cls(self, v):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if isinstance(v, (ProtoBase, RepeatedSequence)):
            self._establish_parentage_r_cls(v)
        self._cache[49] = v
        self._mods[49] = self.TYPE_Repeated_r_cls

    def _mod_r_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        self._mods[49] = self.TYPE_Repeated_r_cls

    def _del_r_cls(self):
        self._evermod = True
        if self._pbf_parent_callback:
            self._pbf_parent_callback()
        if 49 in self._cache:
            del self._cache[49]
        if 49 in self._mods:
            del self._mods[49]
        self._buf_del(49)

    _pb_field_name_49 = "r_cls"

    r_cls = property(_get_r_cls, _set_r_cls, _del_r_cls)

    @property
    def r_cls__exists(self):
        return 49 in self._mods or self._buf_exists(49)


